/*!
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
  */
  
import { IgcSpreadsheetModule, RendererContainer, SpreadsheetDialogUtilities, SpreadsheetUtilities, SpreadsheetChartAdapterBase, SpreadsheetChartElementInfo } from 'igniteui-webcomponents-spreadsheet';
import { Localization, Base, markType, List$1, typeCast, Enumerable, stringContains, stringEmpty, trimEnd, StringBuilder, stringFormat1, truncate, fromEnum, stringRemove, CategoryXAxisDescription, CategoryYAxisDescription, stringFormat, tryParseNumber, fromOADate, stringIsNullOrEmpty, CategoryAngleAxisDescription, NumericRadiusAxisDescription, NumericXAxisDescription, NumericYAxisDescription, Number_$type, String_$type, EnumUtil, nullableEquals, StraightNumericAxisBaseDescription, AxisDescription, ValueType, isNaN_, ArgumentException, isInfinity, markStruct, runOn, ComponentRenderer, IDisposable_$type, NotSupportedException, Dictionary$2, HashSet$1, Convert, DataChartCategoryCoreDescriptionModule, DataChartCategoryDescriptionModule, DataChartVerticalCategoryDescriptionModule, DataChartDescription, SeriesDescription, HorizontalAnchoredCategorySeriesDescription, DoughnutChartDescriptionMetadata, DoughnutChartDescription, RingSeriesDescription, LegendDescriptionModule, ItemLegendDescriptionModule, LegendDescription, ItemLegendDescription, PieChartDescriptionModule, PieChartDescription, DataChartFinancialDescriptionModule, LineSeriesDescription, ColumnSeriesDescription, FinancialPriceSeriesDescription, typeGetValue, SeriesViewerDescription, MarkerSeriesDescription, StackedFragmentSeriesDescription, BubbleSeriesDescription, StackedSeriesBaseDescription, TrendLineType_$type, AnchoredCategorySeriesDescription, ScatterBaseDescription, PolarBaseDescription, Stacked100AreaSeriesDescription, StackedAreaSeriesDescription, AreaSeriesDescription, Stacked100LineSeriesDescription, StackedLineSeriesDescription, BarSeriesDescription, Stacked100BarSeriesDescription, StackedBarSeriesDescription, Stacked100ColumnSeriesDescription, StackedColumnSeriesDescription, HorizontalStackedSeriesBaseDescription, VerticalStackedSeriesBaseDescription, VerticalAnchoredCategorySeriesDescription, RingSeriesBaseDescriptionMetadata, RingSeriesDescriptionMetadata, HierarchicalRingSeriesDescriptionMetadata, DataChartRadialCoreDescriptionModule, DataChartRadialDescriptionModule, RadialAreaSeriesDescription, RadialLineSeriesDescription, DataChartScatterDescriptionModule, ScatterSplineSeriesDescription, ScatterLineSeriesDescription, ScatterSeriesDescription, DataChartStackedDescriptionModule, log10, markEnum } from 'igniteui-webcomponents-core';
import { IgcDataChartCoreModule, IgcPieChartModule, IgcLineSeriesModule, IgcAreaSeriesModule, IgcColumnSeriesModule, IgcBarSeriesModule, IgcSplineSeriesModule, IgcSplineAreaSeriesModule, IgcStepLineSeriesModule, IgcStepAreaSeriesModule, IgcPointSeriesModule, IgcWaterfallSeriesModule, IgcCrosshairLayerModule, IgcCalloutLayerModule, IgcItemToolTipLayerModule, IgcCategoryToolTipLayerModule, IgcCategoryHighlightLayerModule, IgcCategoryItemHighlightLayerModule, IgcFinalValueLayerModule, IgcNumberAbbreviatorModule, IgcDataChartInteractivityModule, IgcDataChartCategoryTrendLineModule, IgcDataChartAnnotationModule, IgcDoughnutChartModule, IgcCategoryXAxisModule, IgcNumericYAxisModule, IgcCategoryDateTimeXAxisModule, IgcTimeXAxisModule, IgcOrdinalTimeXAxisModule, IgcNumericRadiusAxisModule, IgcNumericAngleAxisModule, IgcCategoryAngleAxisModule, IgcCategoryYAxisModule, IgcNumericXAxisModule, IgcRadialColumnSeriesModule, IgcRadialPieSeriesModule, IgcRadialLineSeriesModule, IgcRadialAreaSeriesModule, IgcPolarLineSeriesModule, IgcPolarSplineSeriesModule, IgcPolarAreaSeriesModule, IgcPolarSplineAreaSeriesModule, IgcPolarScatterSeriesModule, IgcRangeAreaSeriesModule, IgcRangeColumnSeriesModule, IgcPercentChangeYAxisModule, IgcFinancialPriceSeriesModule, IgcIndicatorsModule, IgcOverlaysModule, IgcZoomSliderModule, IgcFinancialLegendModule, IgcLegendModule, IgcItemLegendModule, IgcScatterSeriesModule, IgcScatterLineSeriesModule, IgcScatterSplineSeriesModule, IgcBubbleSeriesModule, IgcStackedAreaSeriesModule, IgcStackedBarSeriesModule, IgcStackedColumnSeriesModule, IgcStackedLineSeriesModule, IgcStacked100AreaSeriesModule, IgcStacked100BarSeriesModule, IgcStacked100ColumnSeriesModule, IgcStacked100LineSeriesModule, IgcStackedFragmentSeriesModule, IgcAreaFragmentModule, IgcRingSeriesModule, IgcColumnFragmentModule, IgcLineFragmentModule, IgcSplineFragmentModule, IgcSplineAreaFragmentModule, IgcBarFragmentModule, NumericAxisBase, Axis, AxisLabelsLocation_$type, PriceDisplayType_$type, MarkerType_$type } from 'igniteui-webcomponents-charts';
import { Workbook, ChartSolidFill, ChartGradientFill, WorkbookColorInfo, ChartType_$type, SeriesType_$type, ChartEmptyFill, Series } from 'igniteui-webcomponents-excel';

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class SpreadsheetChartAdapterLocaleEn {
    constructor() {
        this["Error_CannotDetermineSeriesForChartType"] = "Cannot determine Series for Chart type '{0}'.";
        this["Error_ChartTypeNotSupportedForRendering"] = "Chart type '{0}' is not currently supported for rendering.";
        this["Error_ErrorSettingAxesForSeries"] = "Exception while setting axes for Series type '{0}'.";
        this["Error_InvalidAxesCountOrTypeForChartType"] = "Invalid Excel Axes Count/Types for chart type:  '{0}'.";
        this["Error_UnsupportedSeriesType"] = "Unsupported series type '{0}'.";
    }
}

class IgcSpreadsheetChartAdapterModule {
    static register() {
        IgcSpreadsheetModule.register();
        IgcDataChartCoreModule.register();
        IgcPieChartModule.register();
        IgcLineSeriesModule.register();
        IgcAreaSeriesModule.register();
        IgcColumnSeriesModule.register();
        IgcBarSeriesModule.register();
        IgcSplineSeriesModule.register();
        IgcSplineAreaSeriesModule.register();
        IgcStepLineSeriesModule.register();
        IgcStepAreaSeriesModule.register();
        IgcPointSeriesModule.register();
        IgcWaterfallSeriesModule.register();
        IgcCrosshairLayerModule.register();
        IgcCalloutLayerModule.register();
        IgcItemToolTipLayerModule.register();
        IgcCategoryToolTipLayerModule.register();
        IgcCategoryHighlightLayerModule.register();
        IgcCategoryItemHighlightLayerModule.register();
        IgcFinalValueLayerModule.register();
        IgcNumberAbbreviatorModule.register();
        IgcDataChartInteractivityModule.register();
        IgcDataChartCategoryTrendLineModule.register();
        IgcDataChartAnnotationModule.register();
        IgcDoughnutChartModule.register();
        IgcCategoryXAxisModule.register();
        IgcNumericYAxisModule.register();
        IgcCategoryDateTimeXAxisModule.register();
        IgcTimeXAxisModule.register();
        IgcOrdinalTimeXAxisModule.register();
        IgcNumericRadiusAxisModule.register();
        IgcNumericAngleAxisModule.register();
        IgcCategoryAngleAxisModule.register();
        IgcCategoryYAxisModule.register();
        IgcNumericXAxisModule.register();
        IgcRadialColumnSeriesModule.register();
        IgcRadialPieSeriesModule.register();
        IgcRadialLineSeriesModule.register();
        IgcRadialAreaSeriesModule.register();
        IgcPolarLineSeriesModule.register();
        IgcPolarSplineSeriesModule.register();
        IgcPolarAreaSeriesModule.register();
        IgcPolarSplineAreaSeriesModule.register();
        IgcPolarScatterSeriesModule.register();
        IgcRangeAreaSeriesModule.register();
        IgcRangeColumnSeriesModule.register();
        IgcPercentChangeYAxisModule.register();
        IgcFinancialPriceSeriesModule.register();
        IgcIndicatorsModule.register();
        IgcOverlaysModule.register();
        IgcZoomSliderModule.register();
        IgcFinancialLegendModule.register();
        IgcLegendModule.register();
        IgcItemLegendModule.register();
        IgcScatterSeriesModule.register();
        IgcScatterLineSeriesModule.register();
        IgcScatterSplineSeriesModule.register();
        IgcBubbleSeriesModule.register();
        IgcStackedAreaSeriesModule.register();
        IgcStackedBarSeriesModule.register();
        IgcStackedColumnSeriesModule.register();
        IgcStackedLineSeriesModule.register();
        IgcStacked100AreaSeriesModule.register();
        IgcStacked100BarSeriesModule.register();
        IgcStacked100ColumnSeriesModule.register();
        IgcStacked100LineSeriesModule.register();
        IgcStackedFragmentSeriesModule.register();
        IgcAreaFragmentModule.register();
        IgcRingSeriesModule.register();
        IgcColumnFragmentModule.register();
        IgcLineFragmentModule.register();
        IgcSplineFragmentModule.register();
        IgcSplineAreaFragmentModule.register();
        IgcBarFragmentModule.register();
        Localization.register("spreadsheetchartadapter", new SpreadsheetChartAdapterLocaleEn());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class SpreadsheetChartAdapterLocaleBg {
    constructor() {
        this["Error_CannotDetermineSeriesForChartType"] = "Не могат да бъдат определени Series за Chart типа '{0}'.";
        this["Error_ChartTypeNotSupportedForRendering"] = "Не се поддържа рендериране за Chart типа '{0}'.";
        this["Error_ErrorSettingAxesForSeries"] = "Грешка при задаването на осите на типа Series '{0}'.";
        this["Error_InvalidAxesCountOrTypeForChartType"] = "Невалиден брой оси/типове за тип диаграма: '{0}'.";
        this["Error_UnsupportedSeriesType"] = "Неподдържан тип на сериите: '{0}'.";
        this["LIT_DefaultChartTitle"] = "Име на диаграмата";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgcSpreadsheetChartAdapterLocaleBgModule {
    static register() {
        Localization.register("SpreadsheetChartAdapter-bg", new SpreadsheetChartAdapterLocaleBg());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class SpreadsheetChartAdapterLocaleCs {
    constructor() {
        this["Error_CannotDetermineSeriesForChartType"] = "Pro typ grafu '{0}' nelze určit řadu.";
        this["Error_ChartTypeNotSupportedForRendering"] = "Typ grafu '{0}' není momentálně pro vykreslování podporován.";
        this["Error_ErrorSettingAxesForSeries"] = "Výjimka při nastavování os pro typ série '{0}'.";
        this["Error_InvalidAxesCountOrTypeForChartType"] = "Neplatný počet / typy os Excel pro typ grafu: '{0}'.";
        this["Error_UnsupportedSeriesType"] = "Nepodporovaný typ série '{0}'.";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgcSpreadsheetChartAdapterLocaleCsModule {
    static register() {
        Localization.register("SpreadsheetChartAdapter-cs", new SpreadsheetChartAdapterLocaleCs());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class SpreadsheetChartAdapterLocaleDa {
    constructor() {
        this["Error_CannotDetermineSeriesForChartType"] = "Kan ikke bestemme serien for diagramtypen '{0}'.";
        this["Error_ChartTypeNotSupportedForRendering"] = "Diagramtypen '{0}' understøttes i øjeblikket ikke til gengivelse.";
        this["Error_ErrorSettingAxesForSeries"] = "Undtagelse ved indstilling af akser til serietype '{0}'.";
        this["Error_InvalidAxesCountOrTypeForChartType"] = "Ugyldigt antal/type af Excel-akser for diagramtype: '{0}'.";
        this["Error_UnsupportedSeriesType"] = "Ikke-understøttet serietype '{0}'.";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgcSpreadsheetChartAdapterLocaleDaModule {
    static register() {
        Localization.register("SpreadsheetChartAdapter-da", new SpreadsheetChartAdapterLocaleDa());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class SpreadsheetChartAdapterLocaleDe {
    constructor() {
        this["Error_CannotDetermineSeriesForChartType"] = "Serie für Diagrammtyp '{0}‘ kann nicht bestimmt werden.";
        this["Error_ChartTypeNotSupportedForRendering"] = "Diagrammtyp '{0}' wird derzeit nicht für das Rendern unterstützt.";
        this["Error_ErrorSettingAxesForSeries"] = "Ausnahme beim Einstellen der Achsen für Reihentyp '{0}'.";
        this["Error_InvalidAxesCountOrTypeForChartType"] = "Ungültige Excel-Achsenanzahl/Typen für Diagrammtyp:  '{0}'.";
        this["Error_UnsupportedSeriesType"] = "Nicht unterstützter Reihentyp '{0}'.";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgcSpreadsheetChartAdapterLocaleDeModule {
    static register() {
        Localization.register("SpreadsheetChartAdapter-de", new SpreadsheetChartAdapterLocaleDe());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class SpreadsheetChartAdapterLocaleEs {
    constructor() {
        this["Error_CannotDetermineSeriesForChartType"] = "No se puede determinar la serie para el tipo de gráfico '{0}'.";
        this["Error_ChartTypeNotSupportedForRendering"] = "El tipo de gráfico '{0}' no es compatible actualmente para la representación.";
        this["Error_ErrorSettingAxesForSeries"] = "Excepción al establecer los ejes para el tipo de serie '{0}'.";
        this["Error_InvalidAxesCountOrTypeForChartType"] = "Recuento/tipos de ejes de Excel no válidos para el tipo de gráfico: '{0}'.";
        this["Error_UnsupportedSeriesType"] = "Tipo de serie '{0}' no compatible.";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgcSpreadsheetChartAdapterLocaleEsModule {
    static register() {
        Localization.register("SpreadsheetChartAdapter-es", new SpreadsheetChartAdapterLocaleEs());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class SpreadsheetChartAdapterLocaleFr {
    constructor() {
        this["Error_CannotDetermineSeriesForChartType"] = "Impossible de déterminer une série pour le type de graphique '{0}'.";
        this["Error_ChartTypeNotSupportedForRendering"] = "Le type de graphique '{0}’ n’est actuellement pas pris en charge pour l’affichage.";
        this["Error_ErrorSettingAxesForSeries"] = "Exception lors du réglage des axes pour le type de série '{0}'.";
        this["Error_InvalidAxesCountOrTypeForChartType"] = "Nombre/types d’axes Excel non valides pour le type de graphique : '{0}'.";
        this["Error_UnsupportedSeriesType"] = "Type de série non pris en charge '{0}'.";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgcSpreadsheetChartAdapterLocaleFrModule {
    static register() {
        Localization.register("SpreadsheetChartAdapter-fr", new SpreadsheetChartAdapterLocaleFr());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class SpreadsheetChartAdapterLocaleHu {
    constructor() {
        this["Error_CannotDetermineSeriesForChartType"] = "Nem lehet meghatározni a(z) '{0}' diagramtípus adatsorát.";
        this["Error_ChartTypeNotSupportedForRendering"] = "A(z) '{0}' diagramtípus megjelenítése jelenleg nem támogatott.";
        this["Error_ErrorSettingAxesForSeries"] = "Kivétel a(z) '{0}' adatsortípushoz tartozó tengelyek beállítása során.";
        this["Error_InvalidAxesCountOrTypeForChartType"] = "Érvénytelen Excel tengelyszám/tengelytípus a(z) {0} diagramtípushoz.";
        this["Error_UnsupportedSeriesType"] = "Nem támogatott adatsortípus: {0}.";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgcSpreadsheetChartAdapterLocaleHuModule {
    static register() {
        Localization.register("SpreadsheetChartAdapter-hu", new SpreadsheetChartAdapterLocaleHu());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class SpreadsheetChartAdapterLocaleIt {
    constructor() {
        this["Error_CannotDetermineSeriesForChartType"] = "Impossibile determinare la serie per il tipo di grafico '{0}'.";
        this["Error_ChartTypeNotSupportedForRendering"] = "Il tipo di grafico '{0}' non è attualmente supportato per il rendering.";
        this["Error_ErrorSettingAxesForSeries"] = "Eccezione durante l'impostazione degli assi per il tipo di serie '{0}'.";
        this["Error_InvalidAxesCountOrTypeForChartType"] = "Conteggio / tipi di assi Excel non validi per il tipo di grafico: '{0}'.";
        this["Error_UnsupportedSeriesType"] = "Tipo di serie non supportato '{0}'.";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgcSpreadsheetChartAdapterLocaleItModule {
    static register() {
        Localization.register("SpreadsheetChartAdapter-it", new SpreadsheetChartAdapterLocaleIt());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class SpreadsheetChartAdapterLocaleJa {
    constructor() {
        this["Error_CannotDetermineSeriesForChartType"] = "チャートタイプ '{0}' の系列を決定できません。";
        this["Error_ChartTypeNotSupportedForRendering"] = "レンダリングでチャートタイプ '{0}' は現在サポートされていません。";
        this["Error_ErrorSettingAxesForSeries"] = "シリーズタイプ '{0}' の軸を設定中に例外が発生しました。";
        this["Error_InvalidAxesCountOrTypeForChartType"] = "チャートタイプ '{0}' の Excel 軸数/タイプが無効です。";
        this["Error_UnsupportedSeriesType"] = "サポートされないされるシリーズ タイプ '{0}'。";
        this["LIT_DefaultChartTitle"] = "チャートのタイトル";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgcSpreadsheetChartAdapterLocaleJaModule {
    static register() {
        Localization.register("SpreadsheetChartAdapter-ja", new SpreadsheetChartAdapterLocaleJa());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class SpreadsheetChartAdapterLocaleNb {
    constructor() {
        this["Error_CannotDetermineSeriesForChartType"] = "Kan ikke bestemme serien for diagramtype '{0}'.";
        this["Error_ChartTypeNotSupportedForRendering"] = "Diagramtype '{0}' støttes foreløpig ikke for gjengivelse.";
        this["Error_ErrorSettingAxesForSeries"] = "Unntak under innstilling av akser for serietype {0}.";
        this["Error_InvalidAxesCountOrTypeForChartType"] = "Ugyldig antall Excel -akser/typer for diagramtype: '{0}'.";
        this["Error_UnsupportedSeriesType"] = "Serietype '{0}' støttes ikke.";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgcSpreadsheetChartAdapterLocaleNbModule {
    static register() {
        Localization.register("SpreadsheetChartAdapter-nb", new SpreadsheetChartAdapterLocaleNb());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class SpreadsheetChartAdapterLocaleNl {
    constructor() {
        this["Error_CannotDetermineSeriesForChartType"] = "Kan reeks niet bepalen voor diagramtype '{0}'.";
        this["Error_ChartTypeNotSupportedForRendering"] = "Diagramtype '{0}' wordt momenteel niet ondersteund voor weergave.";
        this["Error_ErrorSettingAxesForSeries"] = "Uitzondering bij het instellen van assen voor serietype '{0}'.";
        this["Error_InvalidAxesCountOrTypeForChartType"] = "Ongeldige telling / typen Excel-assen voor diagramtype: '{0}'.";
        this["Error_UnsupportedSeriesType"] = "Niet-ondersteund serietype '{0}'.";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgcSpreadsheetChartAdapterLocaleNlModule {
    static register() {
        Localization.register("SpreadsheetChartAdapter-nl", new SpreadsheetChartAdapterLocaleNl());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class SpreadsheetChartAdapterLocalePl {
    constructor() {
        this["Error_CannotDetermineSeriesForChartType"] = "Nie można określić serii dla typu wykresu '{0}'.";
        this["Error_ChartTypeNotSupportedForRendering"] = "Renderowanie typu wykresu '{0}' nie jest obecnie obsługiwane.";
        this["Error_ErrorSettingAxesForSeries"] = "Wyjątek podczas ustawiania osi dla typu serii '{0}'.";
        this["Error_InvalidAxesCountOrTypeForChartType"] = "Nieprawidłowa liczba / typy osi programu Excel dla typu wykresu: '{0}'.";
        this["Error_UnsupportedSeriesType"] = "Nieobsługiwany typ serii '{0}'.";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgcSpreadsheetChartAdapterLocalePlModule {
    static register() {
        Localization.register("SpreadsheetChartAdapter-pl", new SpreadsheetChartAdapterLocalePl());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class SpreadsheetChartAdapterLocalePt {
    constructor() {
        this["Error_CannotDetermineSeriesForChartType"] = "Não é possível determinar a série para o tipo de gráfico '{0}'.";
        this["Error_ChartTypeNotSupportedForRendering"] = "Neste momento, o tipo de gráfico '{0}' não é suportado para composição.";
        this["Error_ErrorSettingAxesForSeries"] = "Exceção ao definir eixos para o tipo de série '{0}'.";
        this["Error_InvalidAxesCountOrTypeForChartType"] = "Contagem de eixos do Excel inválida/Tipos para o tipo de gráfico: '{0}'.";
        this["Error_UnsupportedSeriesType"] = "Tipo de série não suportado '{0}'.";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgcSpreadsheetChartAdapterLocalePtModule {
    static register() {
        Localization.register("SpreadsheetChartAdapter-pt", new SpreadsheetChartAdapterLocalePt());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class SpreadsheetChartAdapterLocaleRo {
    constructor() {
        this["Error_CannotDetermineSeriesForChartType"] = "Nu se poate determina Seria pentru tipul de diagramă '{0}'.";
        this["Error_ChartTypeNotSupportedForRendering"] = "Tipul de diagramă '{0}' nu este acceptat în prezent pentru redare.";
        this["Error_ErrorSettingAxesForSeries"] = "Excepție la setarea axelor pentru tipul de serie '{0}'.";
        this["Error_InvalidAxesCountOrTypeForChartType"] = "Numărul / tipurile de axe Excel nevalide pentru tipul de diagramă: '{0}'.";
        this["Error_UnsupportedSeriesType"] = "Tipul de serie neacceptat '{0}'.";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgcSpreadsheetChartAdapterLocaleRoModule {
    static register() {
        Localization.register("SpreadsheetChartAdapter-ro", new SpreadsheetChartAdapterLocaleRo());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class SpreadsheetChartAdapterLocaleRu {
    constructor() {
        this["Error_CannotDetermineSeriesForChartType"] = "Не удается определить ряд для типа диаграммы '{0}'.";
        this["Error_ChartTypeNotSupportedForRendering"] = "В настоящее время визуализация типа диаграммы '{0}' не поддерживается.";
        this["Error_ErrorSettingAxesForSeries"] = "Исключение при настройке осей для типа ряда '{0}'.";
        this["Error_InvalidAxesCountOrTypeForChartType"] = "Недопустимый подсчет/типы осей Excel для типа диаграммы: '{0}'.";
        this["Error_UnsupportedSeriesType"] = "Неподдерживаемый тип ряда '{0}'.";
        this["LIT_DefaultChartTitle"] = "Заголовок диаграммы";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgcSpreadsheetChartAdapterLocaleRuModule {
    static register() {
        Localization.register("SpreadsheetChartAdapter-ru", new SpreadsheetChartAdapterLocaleRu());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class SpreadsheetChartAdapterLocaleSv {
    constructor() {
        this["Error_CannotDetermineSeriesForChartType"] = "Det går inte att bestämma serie för diagramtyp '{0}'.";
        this["Error_ChartTypeNotSupportedForRendering"] = "Diagramtypen '{0}' stöds för närvarande inte för rendering.";
        this["Error_ErrorSettingAxesForSeries"] = "Undantag vid inställning av axlar för serietypen '{0}'.";
        this["Error_InvalidAxesCountOrTypeForChartType"] = "Ogiltiga Excel-axelantal / -typer för diagramtyp: '{0}'.";
        this["Error_UnsupportedSeriesType"] = "Serietypen '{0}' stöds inte.";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgcSpreadsheetChartAdapterLocaleSvModule {
    static register() {
        Localization.register("SpreadsheetChartAdapter-sv", new SpreadsheetChartAdapterLocaleSv());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class SpreadsheetChartAdapterLocaleTr {
    constructor() {
        this["Error_CannotDetermineSeriesForChartType"] = "Grafik türü '{0}' için Seri belirlenemiyor.";
        this["Error_ChartTypeNotSupportedForRendering"] = "Grafik türü '{0}' şu anda oluşturma için desteklenmiyor.";
        this["Error_ErrorSettingAxesForSeries"] = "Seri türü '{0}' için eksenleri ayarlarken istisna.";
        this["Error_InvalidAxesCountOrTypeForChartType"] = "Grafik türü için Geçersiz Excel Eksen Sayısı / Türleri: '{0}'.";
        this["Error_UnsupportedSeriesType"] = "Desteklenmeyen dizi türü '{0}'.";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgcSpreadsheetChartAdapterLocaleTrModule {
    static register() {
        Localization.register("SpreadsheetChartAdapter-tr", new SpreadsheetChartAdapterLocaleTr());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class SpreadsheetChartAdapterLocaleZhHans {
    constructor() {
        this["Error_CannotDetermineSeriesForChartType"] = "无法确定图表类型 '{0}' 系列。";
        this["Error_ChartTypeNotSupportedForRendering"] = "图表类型 '{0}' 当前不支持渲染。";
        this["Error_ErrorSettingAxesForSeries"] = "设置系列类型 '{0}' 的轴时出现例外。";
        this["Error_InvalidAxesCountOrTypeForChartType"] = "图表类型 '{0}' 的无效 Excel 轴计数/类型。";
        this["Error_UnsupportedSeriesType"] = "不支持的系列类型为 '{0}'。";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgcSpreadsheetChartAdapterLocaleZhHansModule {
    static register() {
        Localization.register("SpreadsheetChartAdapter-zh-Hans", new SpreadsheetChartAdapterLocaleZhHans());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class SpreadsheetChartAdapterLocaleZhHant {
    constructor() {
        this["Error_CannotDetermineSeriesForChartType"] = "無法確定圖表類型 '{0}' 的系列。";
        this["Error_ChartTypeNotSupportedForRendering"] = "目前不支援圖表類型 '{0}' 的轉譯。";
        this["Error_ErrorSettingAxesForSeries"] = "設定系列類型 '{0}' 的軸時出現例外。";
        this["Error_InvalidAxesCountOrTypeForChartType"] = "圖表類型 '{0}' 的無效 Excel 軸計數/類型。";
        this["Error_UnsupportedSeriesType"] = "不支援的系列類型 '{0}'。";
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgcSpreadsheetChartAdapterLocaleZhHantModule {
    static register() {
        Localization.register("SpreadsheetChartAdapter-zh-Hant", new SpreadsheetChartAdapterLocaleZhHant());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgcSpreadsheetChartAdapterLocaleEnModule {
    static register() {
        Localization.register("SpreadsheetChartAdapter-en", new SpreadsheetChartAdapterLocaleEn());
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SpreadsheetChartAdapterState = /*@__PURE__*/ (() => {
    class SpreadsheetChartAdapterState extends Base {
        constructor(a, b, c, d, e) {
            super();
            this.d = 0;
            this.f = null;
            this.g = null;
            this.a = null;
            this.c = null;
            this.b = null;
            this.c = a;
            this.f = b;
            this.g = c;
            this.a = d;
            this.b = e;
        }
        e() {
            this.d++;
            return this.d;
        }
    }
    SpreadsheetChartAdapterState.$t = /*@__PURE__*/ markType(SpreadsheetChartAdapterState, 'SpreadsheetChartAdapterState');
    return SpreadsheetChartAdapterState;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartElementPlatformHelper = /*@__PURE__*/ (() => {
    class ChartElementPlatformHelper extends Base {
        constructor(a, b) {
            super();
            this.a = null;
            this.l = null;
            this.b = null;
            this.a = a;
            this.l = new List$1(RendererContainer.$, 0);
            this.b = b;
        }
        c(a, b, c, d = false, e = 3, f = 3) {
            let g = this.m(a, b);
            if (null == g) {
                return false;
            }
            return true;
        }
        s(a, b, c, d = false, e = 0, f = 0, g = 1, h = 1, i = 3, j = 3, k = 0) {
            if (this.f(a)) {
                if (a.tagName.toLowerCase() != "div") {
                    return;
                }
            }
            let l = this.m(b, a);
            if (null == l) {
                return;
            }
            let m = this.q(l);
            switch (i) {
                case 0:
                    m += " justify-self: start;";
                    break;
                case 2:
                    m += " justify-self: end;";
                    break;
                case 3:
                    m += " justify-self: stretch;";
                    break;
                case 1:
                    m += " justify-self: center;";
                    break;
            }
            switch (j) {
                case 0:
                    m += " align-self: start;";
                    break;
                case 2:
                    m += " align-self: end;";
                    break;
                case 3:
                    m += " align-self: stretch;";
                    break;
                case 1:
                    m += " align-self: center;";
                    break;
            }
            let n = SpreadsheetDialogUtilities.j(e + 1, g, f + 1, h, m + " display: block;");
            l.setAttribute("style", n);
        }
        d(a, b) {
            let c = typeCast(RendererContainer.$, b);
            if (null == c) {
                return false;
            }
            a.clearRefValues(c.container);
            return true;
        }
        t(a) {
            if (false == this.f(a)) {
                return;
            }
            if (a.tagName.toLowerCase() != "div") {
                return;
            }
            let b = a;
            for (let c = b.children.length; c > 0; c--) {
                b.removeChild(b.children.item(c - 1));
            }
        }
        u(a) {
        }
        n() {
            return null;
        }
        e(a) {
            let b = typeCast(RendererContainer.$, a);
            return b.isReady;
        }
        o(a) {
            let b = this.a.createRendererContainer();
            this.l.add(b);
            a = b.isReady;
            b.onReady = this.b;
            return {
                ret: b,
                p0: a
            };
        }
        p() {
            return document.createElement("div");
        }
        v(a, b, c, d) {
            this.g(a, b, c, ((e) => d(null, e)));
        }
        w(a, b, c, d) {
            this.g(a, b, c, ((e, f) => {
                let g = e.bf;
                if (null == g) {
                    return;
                }
                let h = Enumerable.af(NumericAxisBase.$, Enumerable.l(NumericAxisBase.$, Enumerable.u(Axis.$, g.axes, (i) => stringContains(i.name, "Primary"))));
                let i = Enumerable.af(NumericAxisBase.$, Enumerable.l(NumericAxisBase.$, Enumerable.u(Axis.$, g.axes, (j) => stringContains(j.name, "Secondary"))));
                if (h != null && i != null && h.lu != 0 && i.lu != 0) {
                    let j = h.lw;
                    let k = h.lv;
                    let l = h.lu;
                    let m = l / (k - j);
                    let n = i.lw;
                    let o = i.lv;
                    let p = i.lu;
                    p = m * (o - n);
                    let q = d(p, false);
                    let r = (o - n) * q / p;
                    o = n + r;
                    i.l4 = n;
                    i.l0 = p;
                    i.l3 = o;
                }
            }));
        }
        g(a, b, c, d) {
            let e = typeCast(RendererContainer.$, b);
            if (null == e) {
                return false;
            }
            a.provideRefValue(e.container, c, d);
            return true;
        }
        h(a, b) {
            let c = null;
            if (this.f(b)) {
                c = b;
            }
            else {
                return false;
            }
            let d = null;
            if (this.f(a)) {
                d = a;
            }
            else if (typeCast(RendererContainer.$, a) !== null) {
                d = a.containerElement;
            }
            else {
            }
            if (null == d) {
                return false;
            }
            c.removeChild(d);
            return true;
        }
        i(a, b, c) {
            let d = typeCast(RendererContainer.$, b);
            if (null == d) {
                return false;
            }
            a.removeRefValue(d.container, c);
            return true;
        }
        x(a, b, c) {
            let d = typeCast(RendererContainer.$, c);
            if (null == d) {
                return;
            }
            a.render(b, d.container);
        }
        j(a, b, c, d, e) {
            return false;
        }
        k(a, b, c) {
            if (false == (this.f(a) && a.tagName.toLowerCase() == "div")) {
                return false;
            }
            let d = (e) => {
                let f = stringEmpty();
                for (let h = 0; h < e.length; h++) {
                    let g = e[h];
                    if (g.e) {
                        f += g.i.toString() + "px ";
                    }
                    else if (g.g) {
                        f += "minmax(0," + g.i.toString() + "fr) ";
                    }
                    else if (g.f) {
                        f += "auto ";
                    }
                }
                return trimEnd(f);
            };
            let e = a;
            let f = SpreadsheetDialogUtilities.k(d(b), d(c), "0px", "height: 100%; box-sizing: border-box; ");
            e.setAttribute("style", f);
            return false;
        }
        m(a, b) {
            let c = null;
            if (this.f(b)) {
                c = b;
            }
            else if (typeCast(RendererContainer.$, b) !== null) {
                c = b.containerElement;
            }
            else {
                return null;
            }
            let d = null;
            if (this.f(a)) {
                d = a;
            }
            else if (typeCast(RendererContainer.$, a) !== null) {
                d = a.containerElement;
            }
            else {
            }
            if (null == d) {
                return null;
            }
            c.appendChild(d);
            return d;
        }
        q(a) {
            let b = a.getAttribute("style");
            if (null == b) {
                return stringEmpty();
            }
            return b;
        }
        f(a) {
            let b = a.toString().toLowerCase();
            return stringContains(b, "element") || stringContains(b, "html");
        }
    }
    ChartElementPlatformHelper.$t = /*@__PURE__*/ markType(ChartElementPlatformHelper, 'ChartElementPlatformHelper');
    return ChartElementPlatformHelper;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartSeriesInfo = /*@__PURE__*/ (() => {
    class ChartSeriesInfo extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.c = null;
            this.d = null;
            this.b = 0;
        }
    }
    ChartSeriesInfo.$t = /*@__PURE__*/ markType(ChartSeriesInfo, 'ChartSeriesInfo');
    return ChartSeriesInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SpreadsheetChartAdapter_ScatterSeriesDataItem = /*@__PURE__*/ (() => {
    class SpreadsheetChartAdapter_ScatterSeriesDataItem extends Base {
        constructor(a, b, c, d) {
            super();
            this._Radius = 0;
            this._X = 0;
            this._Y = 0;
            this._SeriesName = null;
            this.X = a;
            this.Y = b;
            this.Radius = c;
            this.SeriesName = d;
        }
        get Radius() {
            return this._Radius;
        }
        set Radius(a) {
            this._Radius = a;
        }
        get X() {
            return this._X;
        }
        set X(a) {
            this._X = a;
        }
        get Y() {
            return this._Y;
        }
        set Y(a) {
            this._Y = a;
        }
        get SeriesName() {
            return this._SeriesName;
        }
        set SeriesName(a) {
            this._SeriesName = a;
        }
    }
    SpreadsheetChartAdapter_ScatterSeriesDataItem.$t = /*@__PURE__*/ markType(SpreadsheetChartAdapter_ScatterSeriesDataItem, 'SpreadsheetChartAdapter_ScatterSeriesDataItem');
    return SpreadsheetChartAdapter_ScatterSeriesDataItem;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SpreadsheetChartAdapter_SeriesDataItem = /*@__PURE__*/ (() => {
    class SpreadsheetChartAdapter_SeriesDataItem extends Base {
        constructor() {
            super(...arguments);
            this._Col = null;
            this._Row = null;
            this._Value = 0;
        }
        get Col() {
            return this._Col;
        }
        set Col(a) {
            this._Col = a;
        }
        get Row() {
            return this._Row;
        }
        set Row(a) {
            this._Row = a;
        }
        get Value() {
            return this._Value;
        }
        set Value(a) {
            this._Value = a;
        }
    }
    SpreadsheetChartAdapter_SeriesDataItem.$t = /*@__PURE__*/ markType(SpreadsheetChartAdapter_SeriesDataItem, 'SpreadsheetChartAdapter_SeriesDataItem');
    return SpreadsheetChartAdapter_SeriesDataItem;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AxisInfo = /*@__PURE__*/ (() => {
    class AxisInfo extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
            this.a = null;
            this.d = false;
            this.i = false;
            this.j = false;
            this.k = false;
            this.g = false;
            this.h = false;
            this.c = false;
            this.f = false;
            this.e = false;
        }
    }
    AxisInfo.$t = /*@__PURE__*/ markType(AxisInfo, 'AxisInfo');
    return AxisInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SpreadsheetChartAdapter_StackedSeriesDataItem = /*@__PURE__*/ (() => {
    class SpreadsheetChartAdapter_StackedSeriesDataItem extends Base {
        constructor() {
            super(...arguments);
            this._CategoryName = null;
            this._SeriesNames = null;
            this._SeriesValues = null;
        }
        get CategoryName() {
            return this._CategoryName;
        }
        set CategoryName(a) {
            this._CategoryName = a;
        }
        get SeriesNames() {
            return this._SeriesNames;
        }
        set SeriesNames(a) {
            this._SeriesNames = a;
        }
        get SeriesValues() {
            return this._SeriesValues;
        }
        set SeriesValues(a) {
            this._SeriesValues = a;
        }
    }
    SpreadsheetChartAdapter_StackedSeriesDataItem.$t = /*@__PURE__*/ markType(SpreadsheetChartAdapter_StackedSeriesDataItem, 'SpreadsheetChartAdapter_StackedSeriesDataItem');
    return SpreadsheetChartAdapter_StackedSeriesDataItem;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SpreadsheetChartAdapterHelpers = /*@__PURE__*/ (() => {
    class SpreadsheetChartAdapterHelpers extends Base {
        static p(a) {
            let b = new StringBuilder(0);
            for (let d = 0; d < a.length; d++) {
                let c = a[d];
                let e = null == c ? "<null>" : c.toString();
                b.l(e + ", ");
            }
            return b.toString();
        }
        static n(a, b, c) {
            return SpreadsheetChartAdapterHelpers.o(Workbook._eq(a), b, c);
        }
        static o(a, b, c) {
            return Workbook._er(b, a, c);
        }
        static e(a, b) {
            switch (a) {
                case 0: return 7;
                case 1: return 1;
                case 2: return 6;
                case 3: return 9;
                case 4:
                    {
                        switch (b) {
                            case 6: return 5;
                            case 5: return 5;
                            case 4: return 4;
                            case 3: return 3;
                            case 2: return 2;
                            default: return 2;
                        }
                    }
                case 5: return 8;
                default: return 1;
            }
        }
        static q(a, b, c, d) {
            let e = a / 255;
            return stringFormat1("rgba({0},{1},{2},{3})", b, c, d, e.toString());
        }
        static r(a, b) {
            if (null != a) {
                if (typeCast(ChartSolidFill.$, a) !== null) {
                    return SpreadsheetChartAdapterHelpers.t(typeCast(ChartSolidFill.$, a), b);
                }
                else if (typeCast(ChartGradientFill.$, a) !== null) {
                    return SpreadsheetChartAdapterHelpers.s(typeCast(ChartGradientFill.$, a), b);
                }
            }
            return stringEmpty();
        }
        static s(a, b) {
            let c = "linear-gradient(";
            let d = truncate(a.angle);
            d += 90;
            if (d >= 360) {
                d -= 360;
            }
            c += d.toString() + "deg, ";
            switch (a.gradientType) {
                case 0:
                case 1:
                case 3:
                case 2:
                    {
                        for (let e of fromEnum(a.getStops())) {
                            c += SpreadsheetChartAdapterHelpers.u(e.color, b);
                            c += " " + truncate((e.position * 100)).toString() + "%, ";
                        }
                        c = stringRemove(c, (c.length - 2), 2);
                        break;
                    }
            }
            c += ")";
            return c;
        }
        static t(a, b) {
            return SpreadsheetChartAdapterHelpers.u(a.color, b);
        }
        static u(a, b) {
            if (WorkbookColorInfo.l_op_Equality(null, a) || null == b) {
                return stringEmpty();
            }
            return SpreadsheetChartAdapterHelpers.q(a._getResolvedColor1(b).l, a._getResolvedColor1(b).o, a._getResolvedColor1(b).n, a._getResolvedColor1(b).m);
        }
        static c(a) {
            switch (a) {
                case 0:
                case 1: return 1;
                case 2: return 2;
                case 3: return 3;
                case 4: return 0;
                default: return 1;
            }
        }
        static d(a) {
            let b = true;
            switch (a.position) {
                case 0:
                    if (a.type == 1) {
                        b = false;
                    }
                    break;
                case 1:
                case 4:
                    b = false;
                    break;
            }
            switch (a.tickLabelPosition) {
                case 4: if (b) {
                    return 6;
                }
                else {
                    return 4;
                }
                case -4127: if (b) {
                    return 3;
                }
                else {
                    return 0;
                }
                case -4134: if (b) {
                    return 2;
                }
                else {
                    return 1;
                }
                default:
                    {
                        switch (a.position) {
                            case 0:
                            case 2: return 2;
                            case 4: return 0;
                            case 3: return 3;
                            case 1: return 1;
                            default: return 1;
                        }
                    }
            }
        }
        static g(a, b) {
            let c = SpreadsheetChartAdapterHelpers.m(a, b);
            let d = null;
            if (c) {
                d = new CategoryXAxisDescription();
            }
            else {
                d = new CategoryYAxisDescription();
            }
            if (c) {
                d.name = a.axisGroup == 1 ? "XAxisPrimary" : "XAxisSecondary";
            }
            else {
                d.name = a.axisGroup == 1 ? "YAxisPrimary" : "YAxisSecondary";
            }
            SpreadsheetChartAdapterHelpers.x(d, a, b);
            d.label = "Row";
            d.dataSourceRef = stringFormat("groupedseriesdata{0}", "0");
            if (c) {
                d.interval = a.tickLabelSpacing;
            }
            else {
                d.interval = a.tickLabelSpacing;
            }
            d.useClusteringMode = true;
            if (a.visible) {
                let e = a._y();
                let f = "formatlabelcategoryaxis_" + d.name;
                b.b.v(b.a, b.f, f, (g, h) => {
                    let i = stringEmpty();
                    if (typeCast(SpreadsheetChartAdapter_SeriesDataItem.$, h) !== null) {
                        i = h.Row;
                    }
                    else if (typeCast(SpreadsheetChartAdapter_StackedSeriesDataItem.$, h) !== null) {
                        i = h.CategoryName;
                    }
                    let j = 0;
                    if (a.categoryType == 2) {
                        return i;
                    }
                    else if (a.categoryType == 3) {
                        if (((() => { let k = tryParseNumber(i, j); j = k.p1; return k.ret; })())) {
                            return SpreadsheetUtilities.dw(fromOADate(j), b.c.worksheet);
                        }
                    }
                    else if (null != e) {
                        if (((() => { let k = tryParseNumber(i, j); j = k.p1; return k.ret; })())) {
                            let k = stringEmpty();
                            if (((() => { let l = e.v(j, a.tickLabels.numberFormat, k); k = l.p2; return l.ret; })())) {
                                if (false == stringIsNullOrEmpty(k)) {
                                    return k;
                                }
                            }
                        }
                    }
                    return i;
                });
                d.formatLabelRef = f;
            }
            else {
                d.formatLabelRef = stringEmpty();
            }
            return ((() => {
                let $ret = new AxisInfo();
                $ret.b = a;
                $ret.a = d;
                $ret.g = a.axisGroup == 1;
                $ret.h = a.axisGroup == 2;
                $ret.j = c;
                $ret.k = !c;
                $ret.d = true;
                $ret.i = false;
                $ret.c = false;
                $ret.e = false;
                $ret.f = false;
                return $ret;
            })());
        }
        static f(a, b) {
            let c = new CategoryAngleAxisDescription();
            c.name = "CategoryAngleAxis";
            SpreadsheetChartAdapterHelpers.x(c, a, b);
            c.label = "Row";
            c.dataSourceRef = stringFormat("groupedseriesdata{0}", "0");
            c.interval = 1;
            c.gap = 0.35;
            c.useClusteringMode = true;
            return ((() => {
                let $ret = new AxisInfo();
                $ret.b = a;
                $ret.a = c;
                $ret.g = a.axisGroup == 1;
                $ret.h = a.axisGroup == 2;
                $ret.j = false;
                $ret.k = false;
                $ret.d = true;
                $ret.i = false;
                $ret.c = true;
                $ret.e = false;
                $ret.f = false;
                return $ret;
            })());
        }
        static h(a, b) {
            let c = new NumericRadiusAxisDescription();
            c.name = "NumericRadiusAxis";
            SpreadsheetChartAdapterHelpers.x(c, a, b);
            c.interval = 1;
            c.isLogarithmic = a.scaleType == -4133;
            if (false == a.minimumScaleIsAuto) {
                c.minimumValue = a.minimumScale;
            }
            if (false == a.maximumScaleIsAuto) {
                c.maximumValue = a.maximumScale;
            }
            return ((() => {
                let $ret = new AxisInfo();
                $ret.b = a;
                $ret.a = c;
                $ret.g = a.axisGroup == 1;
                $ret.h = a.axisGroup == 2;
                $ret.j = false;
                $ret.k = false;
                $ret.d = false;
                $ret.i = true;
                $ret.c = false;
                $ret.e = false;
                $ret.f = true;
                return $ret;
            })());
        }
        static i(a, b) {
            let c = SpreadsheetChartAdapterHelpers.m(a, b);
            let d = null;
            if (c) {
                d = new NumericXAxisDescription();
            }
            else {
                d = new NumericYAxisDescription();
            }
            if (c) {
                d.name = a.axisGroup == 1 ? "XAxisPrimary" : "XAxisSecondary";
            }
            else {
                d.name = a.axisGroup == 1 ? "YAxisPrimary" : "YAxisSecondary";
            }
            SpreadsheetChartAdapterHelpers.x(d, a, b);
            d.isLogarithmic = a.scaleType == -4133;
            if (false == a.minimumScaleIsAuto) {
                d.minimumValue = a.minimumScale;
            }
            if (false == a.maximumScaleIsAuto) {
                d.maximumValue = a.maximumScale;
            }
            if (false == a.majorUnitIsAuto) {
                d.interval = a.majorUnit;
            }
            if (false == a.minorUnitIsAuto) {
                d.minorInterval = a.minorUnit;
            }
            if (a.visible) {
                let e = a._y();
                let f = "formatlabelvalueaxis_" + d.name;
                b.b.v(b.a, b.f, f, (g, h) => {
                    if (null != h && typeof h === 'number') {
                        let i = h;
                        if (null != e) {
                            let j = stringEmpty();
                            if (((() => { let k = e.v(i, a.tickLabels.numberFormat, j); j = k.p2; return k.ret; })())) {
                                return j;
                            }
                        }
                    }
                    if (null != h) {
                        return h.toString();
                    }
                    else {
                        return stringEmpty();
                    }
                });
                d.formatLabelRef = f;
            }
            else {
                d.formatLabelRef = stringEmpty();
            }
            if (a.logBase != 10) {
                d.isLogarithmic = true;
                d.logarithmBase = truncate(a.logBase);
            }
            return ((() => {
                let $ret = new AxisInfo();
                $ret.b = a;
                $ret.a = d;
                $ret.g = a.axisGroup == 1;
                $ret.h = a.axisGroup == 2;
                $ret.j = c;
                $ret.k = !c;
                $ret.d = false;
                $ret.i = true;
                $ret.c = false;
                $ret.e = false;
                $ret.f = false;
                return $ret;
            })());
        }
        static j(a, b, c) {
            for (let d of fromEnum(b)) {
                if (SpreadsheetChartAdapterHelpers.l(d, a, c)) {
                    return d;
                }
            }
            return null;
        }
        static a(a, b, c) {
            c = 0;
            let d = new List$1(Number_$type, 0);
            let e = a._dataPointCollection$i;
            for (let f = 0; f < e.count; f++) {
                let g = e.item(f);
                if (g._a3 > 0) {
                    d.add(f);
                    c = Math.max(c, g._a3);
                }
            }
            return {
                ret: d.toArray(),
                p2: c
            };
        }
        static b(a, b) {
            let c = new List$1(String_$type, 0);
            let d = a._dataPointCollection$i.count;
            for (let e = 0; e < d; e++) {
                let f = a._dataPointCollection$i.item(e);
                c.add(SpreadsheetChartAdapterHelpers.r(f._aj(e), a.workbook));
            }
            return c.toArray();
        }
        static k(a) {
            return stringContains(EnumUtil.getName(ChartType_$type, a.chartType), "Scatter") || stringContains(EnumUtil.getName(ChartType_$type, a.chartType), "Bubble");
        }
        static l(a, b, c) {
            switch (b) {
                case 0: return a.axisGroup == 1 && SpreadsheetChartAdapterHelpers.m(a, c);
                case 1: return a.axisGroup == 1 && SpreadsheetChartAdapterHelpers.m(a, c) == false;
                case 2: return a.axisGroup == 2 && SpreadsheetChartAdapterHelpers.m(a, c);
                case 3: return a.axisGroup == 2 && SpreadsheetChartAdapterHelpers.m(a, c) == false;
                default: return false;
            }
        }
        static m(a, b) {
            let c = b.c._eh(a);
            return c == 4 || c == 1;
        }
        static v(a, b, c = true) {
            let d = a.name;
            let e = EnumUtil.getName(SeriesType_$type, a.type);
            let f = "Series_" + b.toString() + "_" + e;
            if (null == d || stringIsNullOrEmpty(d.toString().trim())) {
                return f;
            }
            return d.toString() + "_" + e;
        }
        static w(a, b) {
            let c = a.name;
            let d = stringEmpty();
            if (null == c || stringIsNullOrEmpty(d = c.toString().trim())) {
                return "Series " + b.toString();
            }
            return d;
        }
        static x(a, b, c) {
            if (b.axisGroup == 1) {
                a.crossingValue = b.crossesAt;
            }
            if (null != b.tickLines) {
                let d = SpreadsheetChartAdapterHelpers.n(b.tickLines.widthInPoints, b.workbook, false);
                let e = SpreadsheetChartAdapterHelpers.r(b.tickLines.fill, b.workbook);
                if (false == stringIsNullOrEmpty(e)) {
                    a.tickStroke = e;
                    a.stroke = e;
                }
                a.tickStrokeThickness = d;
                a.tickLength = 10;
                a.strokeThickness = d;
            }
            if (null != b.axisTitle) {
                if (null != b.axisTitle.text) {
                    a.title = b.axisTitle.text.toString();
                }
                a.titleAngle = b.axisTitle.rotation;
                let f = SpreadsheetChartAdapterHelpers.u(b.axisTitle._a7, b.workbook);
                if (false == stringIsNullOrEmpty(f)) {
                    a.titleTextColor = f;
                }
                let g = b.axisTitle._a3();
                if (null != g) {
                    a.titleFontStyle = nullableEquals(g._italic$i, true) ? "Italic" : "Normal";
                    a.titleFontWeight = nullableEquals(g._bold$i, true) ? "Bold" : "Normal";
                    a.titleFontSize = SpreadsheetChartAdapterHelpers.o(g.height, b.workbook, true);
                    if (false == stringIsNullOrEmpty(g.name) && false == stringContains(g.name, "+mn-lt")) {
                        a.titleFontFamily = g.name + ", Calibri";
                    }
                    else {
                        a.titleFontFamily = "Calibri";
                    }
                }
            }
            if (null != b.tickLabels) {
                let h = b.tickLabels._an;
                if (null != h) {
                    a.labelFontStyle = nullableEquals(h._italic$i, true) ? "Italic" : "Normal";
                    a.labelFontWeight = nullableEquals(h._bold$i, true) ? "Bold" : "Normal";
                    a.labelFontSize = SpreadsheetChartAdapterHelpers.o(h.height, b.workbook, true);
                    if (false == stringIsNullOrEmpty(h.name) && false == stringContains(h.name, "+mn-lt")) {
                        a.labelFontFamily = h.name + ", Calibri";
                    }
                    else {
                        a.labelFontFamily = "Calibri";
                    }
                }
                let i = SpreadsheetChartAdapterHelpers.u(b.tickLabels._ao, b.workbook);
                if (false == stringIsNullOrEmpty(i)) {
                    a.labelTextColor = i;
                }
                a.labelAngle = b.tickLabels.rotation;
                if (b.tickLabelPosition != -4142) {
                    a.labelLocation = EnumUtil.getName(AxisLabelsLocation_$type, SpreadsheetChartAdapterHelpers.c(b.position));
                }
                else {
                    a.labelTextColor = "rgba(0, 0, 0, 0)";
                }
            }
            if (null != b.majorGridLines) {
                let j = SpreadsheetChartAdapterHelpers.r(b.majorGridLines.fill, b.workbook);
                if (false == stringIsNullOrEmpty(j)) {
                    a.majorStroke = j;
                }
                a.majorStrokeThickness = SpreadsheetChartAdapterHelpers.n(b.majorGridLines.widthInPoints, c.c.worksheet.workbook, false);
            }
            else {
                a.majorStroke = "rgba(0, 0, 0, 0)";
            }
            if (null != b.minorGridLines) {
                let k = SpreadsheetChartAdapterHelpers.r(b.minorGridLines.fill, b.workbook);
                if (false == stringIsNullOrEmpty(k)) {
                    a.minorStroke = k;
                }
                a.minorStrokeThickness = SpreadsheetChartAdapterHelpers.n(b.minorGridLines.widthInPoints, c.c.worksheet.workbook, false);
            }
            else {
                a.minorStroke = "rgba(0, 0, 0, 0)";
            }
            a.labelVisibility = (false == b.visible) ? "Collapsed" : "Visible";
            if (b.reversePlotOrder) {
                a.isInverted = true;
            }
        }
    }
    SpreadsheetChartAdapterHelpers.$t = /*@__PURE__*/ markType(SpreadsheetChartAdapterHelpers, 'SpreadsheetChartAdapterHelpers');
    return SpreadsheetChartAdapterHelpers;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SpreadsheetChartAdapter_PieDataItem = /*@__PURE__*/ (() => {
    class SpreadsheetChartAdapter_PieDataItem extends Base {
        constructor() {
            super(...arguments);
            this._CategoryName = null;
            this._SeriesName = null;
            this._Value = 0;
        }
        get CategoryName() {
            return this._CategoryName;
        }
        set CategoryName(a) {
            this._CategoryName = a;
        }
        get SeriesName() {
            return this._SeriesName;
        }
        set SeriesName(a) {
            this._SeriesName = a;
        }
        get Value() {
            return this._Value;
        }
        set Value(a) {
            this._Value = a;
        }
    }
    SpreadsheetChartAdapter_PieDataItem.$t = /*@__PURE__*/ markType(SpreadsheetChartAdapter_PieDataItem, 'SpreadsheetChartAdapter_PieDataItem');
    return SpreadsheetChartAdapter_PieDataItem;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SpreadsheetChartAdapter_StockDataItem = /*@__PURE__*/ (() => {
    class SpreadsheetChartAdapter_StockDataItem extends Base {
        constructor() {
            super(...arguments);
            this._Open = 0;
            this._High = 0;
            this._Low = 0;
            this._Close = 0;
            this._Volume = 0;
            this._CategoryName = null;
        }
        get Open() {
            return this._Open;
        }
        set Open(a) {
            this._Open = a;
        }
        get High() {
            return this._High;
        }
        set High(a) {
            this._High = a;
        }
        get Low() {
            return this._Low;
        }
        set Low(a) {
            this._Low = a;
        }
        get Close() {
            return this._Close;
        }
        set Close(a) {
            this._Close = a;
        }
        get Volume() {
            return this._Volume;
        }
        set Volume(a) {
            this._Volume = a;
        }
        get CategoryName() {
            return this._CategoryName;
        }
        set CategoryName(a) {
            this._CategoryName = a;
        }
        g(a, b, c) {
            switch (a) {
                case 88:
                    switch (b) {
                        case 0:
                            this.High = c;
                            break;
                        case 1:
                            this.Low = c;
                            break;
                        case 2:
                            this.Close = c;
                            break;
                    }
                    break;
                case 89:
                    switch (b) {
                        case 0:
                            this.Open = c;
                            break;
                        case 1:
                            this.High = c;
                            break;
                        case 2:
                            this.Low = c;
                            break;
                        case 3:
                            this.Close = c;
                            break;
                    }
                    break;
                case 90:
                    switch (b) {
                        case 0:
                            this.Volume = c;
                            break;
                        case 1:
                            this.High = c;
                            break;
                        case 2:
                            this.Low = c;
                            break;
                        case 3:
                            this.Close = c;
                            break;
                    }
                    break;
                case 91:
                    switch (b) {
                        case 0:
                            this.Volume = c;
                            break;
                        case 1:
                            this.Open = c;
                            break;
                        case 2:
                            this.High = c;
                            break;
                        case 3:
                            this.Low = c;
                            break;
                        case 4:
                            this.Close = c;
                            break;
                    }
                    break;
            }
        }
    }
    SpreadsheetChartAdapter_StockDataItem.$t = /*@__PURE__*/ markType(SpreadsheetChartAdapter_StockDataItem, 'SpreadsheetChartAdapter_StockDataItem');
    return SpreadsheetChartAdapter_StockDataItem;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AxisInfos = /*@__PURE__*/ (() => {
    class AxisInfos extends Base {
        constructor() {
            super();
            this.e = null;
            this.c = null;
            this.d = null;
            this.i = 0;
            this.h = 0;
            this.k = 0;
            this.j = 0;
            this.e = new List$1(AxisInfo.$, 0);
            this.c = new List$1(AxisInfo.$, 0);
            this.d = new List$1(AxisInfo.$, 0);
        }
        get f() {
            return this.c;
        }
        get g() {
            return this.d;
        }
        get b() {
            return this.e;
        }
        l(a) {
            this.e.add(a);
            if (a.g) {
                if (a.d) {
                    this.h++;
                }
                else {
                    this.i++;
                }
            }
            else {
                if (a.d) {
                    this.j++;
                }
                else {
                    this.k++;
                }
            }
            if (typeCast(StraightNumericAxisBaseDescription.$, a.a) !== null && a.b.minimumScaleIsAuto && a.b.maximumScaleIsAuto) {
                if (a.j) {
                    this.f.add(a);
                }
                else if (a.k) {
                    this.g.add(a);
                }
            }
        }
        m(a, b) {
            for (let c = 0; c < this.e.count; c++) {
                let d = this.e._inner[c];
                if ((a && d.g) || (a == false && d.h)) {
                    if (d.d) {
                        if (false == d.c) {
                            this.e._inner[c] = (SpreadsheetChartAdapterHelpers.f(d.b, b));
                            this.e._inner[c].a.isDisabled = false;
                        }
                    }
                    else if (d.i) {
                        if (false == d.f) {
                            this.e._inner[c] = (SpreadsheetChartAdapterHelpers.h(d.b, b));
                            this.e._inner[c].a.isDisabled = false;
                        }
                    }
                }
            }
        }
        n(a, b) {
            if (a) {
                if (this.i > 1) {
                    return;
                }
                for (let c = 0; c < this.e.count; c++) {
                    let d = this.e._inner[c];
                    if (d.g && d.d) {
                        this.e._inner[c] = (SpreadsheetChartAdapterHelpers.i(d.b, b));
                        this.e._inner[c].a.labelLocation = EnumUtil.getName(AxisLabelsLocation_$type, (0));
                        this.e._inner[c].a.isDisabled = false;
                        break;
                    }
                }
            }
            else {
                if (this.k > 1) {
                    return;
                }
                for (let e = 0; e < this.e.count; e++) {
                    let f = this.e._inner[e];
                    if (f.h && f.d) {
                        this.e._inner[e] = SpreadsheetChartAdapterHelpers.i(f.b, b);
                        this.e._inner[e].a.labelLocation = EnumUtil.getName(AxisLabelsLocation_$type, (0));
                        this.e._inner[e].a.isDisabled = false;
                        break;
                    }
                }
            }
        }
        a() {
            let a = new List$1(AxisDescription.$, 0);
            for (let b of fromEnum(this.e)) {
                a.add(b.a);
            }
            return Enumerable.a(AxisDescription.$, a);
        }
    }
    AxisInfos.$t = /*@__PURE__*/ markType(AxisInfos, 'AxisInfos');
    return AxisInfos;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RowColLength = /*@__PURE__*/ (() => {
    class RowColLength extends ValueType {
        constructor(a, ..._rest) {
            super();
            this.h = 0;
            this.c = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        RowColLength.j(c, 1);
                        this.h = c;
                        this.c = 1;
                    }
                    break;
                case 2:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        RowColLength.j(c, d);
                        this.h = ((d == 0) ? 0 : c);
                        this.c = d;
                    }
                    break;
            }
        }
        get e() {
            return this.c == 1;
        }
        get f() {
            return this.c == 0;
        }
        get g() {
            return this.c == 2;
        }
        get d() {
            return this.c;
        }
        static get a() {
            return RowColLength.b;
        }
        get i() {
            if (this.c != 0) {
                return this.h;
            }
            return 1;
        }
        static j(a, b) {
            if (isNaN_(a)) {
                throw new ArgumentException(0);
            }
            if (isInfinity(a)) {
                throw new ArgumentException(0);
            }
            if (b != 0 && b != 1 && b != 2) {
                throw new ArgumentException(0);
            }
        }
    }
    RowColLength.$t = /*@__PURE__*/ markStruct(RowColLength, 'RowColLength');
    RowColLength.b = /*@__PURE__*/ new RowColLength(2, 1, 0);
    return RowColLength;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Creates and initializes chart elements for the spreadsheet based on a [[WorksheetChart]] instance.
 */
let SpreadsheetChartAdapter = /*@__PURE__*/ (() => {
    class SpreadsheetChartAdapter extends SpreadsheetChartAdapterBase {
        constructor() {
            super();
            this._d = null;
            /**
             * @hidden
             */
            this._e = null;
            /**
             * @hidden
             */
            this._c = null;
            this._e = new List$1(ChartType_$type, 1, [1, 76, 77, 57, 58, 59, 15, 87, 51, 52, 53, 113, -4120, 80, 4, 63, 64, 65, 66, 67, 5, -4102, 70, 69, -4151, 82, 81, 88, 89, 90, 91, -4169, 74, 75, 72, 73]);
        }
        /**
         * @hidden
         */
        _a(a, b) {
            this._c = b;
            let c = (d, e) => b._v.createChartTitleElement(d.chartTitle, e);
            return this._d = new SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate(this, a, c);
        }
        /**
         * @hidden
         */
        _b(a) {
            return this._e.contains(a.chartType);
        }
        /**
         * @hidden
         */
        _s(a, ...b) {
            let c;
            c = Localization.getString("spreadsheetchartadapter", a, ...b);
            if (!stringIsNullOrEmpty(c) && b != null && b.length > 0) {
                c = stringFormat1(c, ...b);
            }
            return c;
            return "GetResourceString not Implemented!!!!!!";
        }
    }
    SpreadsheetChartAdapter.$t = /*@__PURE__*/ markType(SpreadsheetChartAdapter, 'SpreadsheetChartAdapter', SpreadsheetChartAdapterBase.$);
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._x = "datachart";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._z = "piechart";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._y = "doughnutchart";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._u = "groupedseriesdata{0}";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._t = "groupedscatterseriesdata{0}";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._ab = "stackedseriesdata";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._w = "piedata";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._ac = "stockdata";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._v = "piecharttooltip";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._q = "doughnutcharttooltip";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._g = "legend";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._aa = "seriestooltip{0}";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._r = "fragmentseriestitle{0}";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._f = "axiscrossingvalue-{0}";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._ak = "XAxis";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._ai = "Prices";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._aj = "Volume";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._ae = "High";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._af = "Low";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._ad = "Close";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._ag = "Open";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._ah = "Volume";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._m = "XAxisPrimary";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._n = "XAxisSecondary";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._o = "YAxisPrimary";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._p = "YAxisSecondary";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._j = "CategoryAngleAxis";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._l = "NumericRadiusAxis";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._k = "NumericAngleAxis";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._h = "rgba(0, 0, 0, 0)";
    /**
     * @hidden
     */
    SpreadsheetChartAdapter._i = "rgba(255, 255, 255, 0)";
    return SpreadsheetChartAdapter;
})();
/**
 * @hidden
 */
let SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate = /*@__PURE__*/ (() => {
    class SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate extends SpreadsheetChartElementInfo {
        constructor(a, b, c) {
            super();
            this.ae = null;
            this.a8 = null;
            this.ai = false;
            this.bb = null;
            this.am = false;
            this.k = null;
            this.l = null;
            this.m = null;
            this.aj = false;
            this.ak = false;
            this.a1 = null;
            this.ay = null;
            this.a0 = null;
            this.ax = null;
            this.a2 = null;
            this.az = null;
            this.a3 = null;
            this.bd = null;
            this.bc = null;
            this.af = null;
            this.al = false;
            this.aw = null;
            this.a7 = -1;
            this.ad = null;
            this.a9 = null;
            this.ba = null;
            this.an = false;
            this.ac = null;
            this.ah = null;
            this.ac = new ChartElementPlatformHelper(a._c, runOn(this, this.bs));
            this.ae = a;
            this.c = b;
            this.ad = c;
            this.f = this.ac.p();
            this.ad = c;
            this.k = new ComponentRenderer();
            this.aj = true;
            this.ak = true;
            this.ah = this.c.worksheet.workbook;
            this.bh();
        }
        h() {
            if (null != this.a8 && typeCast(IDisposable_$type, this.a8) !== null) {
                this.a8.dispose();
            }
            if (null != this.bb && typeCast(IDisposable_$type, this.bb) !== null) {
                this.bb.dispose();
            }
        }
        i() {
        }
        e(a, b, c) {
            if (a != this.c) {
                b = true;
                c = true;
                this.c = a;
            }
            else if (false == b && false == c) {
                return true;
            }
            this.al = true;
            if (b || c) {
                this.bv();
            }
            if (c) {
                this.bu();
            }
            this.bh();
            this.aj = false;
            this.ak = false;
            this.al = false;
            return true;
        }
        get ag() {
            if (null == this.af) {
                this.af = new SpreadsheetChartAdapterState(this.c, this.a8, this.bb, this.k, this.ac);
            }
            return this.af;
        }
        get a4() {
            return this.aw;
        }
        get aq() {
            return (null != this.c.legend && null != this.m && null != this.bb);
        }
        get ar() {
            return 113 == this.c.chartType;
        }
        get at() {
            switch (this.c.chartType) {
                case 88:
                case 89:
                case 90:
                case 91: return true;
                default: return false;
            }
        }
        get as() {
            return stringContains(EnumUtil.getName(ChartType_$type, this.c.chartType), "Stacked");
        }
        be() {
            if (null == this.a8) {
                this.a8 = ((() => { let a = this.ac.o(this.ai); this.ai = a.p0; return a.ret; })());
            }
        }
        bg() {
            if (null != this.c.legend) {
                if (null == this.bb) {
                    this.bb = ((() => { let a = this.ac.o(this.am); this.am = a.p0; return a.ret; })());
                }
            }
            else if (null != this.bb) {
                this.ac.h(this.bb, this.f);
                if (null != this.a8) {
                    this.ac.h(this.bb, this.a8);
                }
                this.bb = null;
            }
        }
        bf(a, b, c, d, e, f, g, h, i = null) {
            if (null != a && (false == (typeCast(ChartEmptyFill.$, a.line.fill) !== null))) {
                f.add(this.v(a, "High", g, h));
            }
            if (null != b && (false == (typeCast(ChartEmptyFill.$, b.line.fill) !== null))) {
                f.add(this.v(b, "Low", g, h));
            }
            if (null != c && (false == (typeCast(ChartEmptyFill.$, c.line.fill) !== null))) {
                f.add(this.v(c, "Close", g, h));
            }
            if (null != d && (false == (typeCast(ChartEmptyFill.$, d.line.fill) !== null))) {
                f.add(this.v(d, "Open", g, h));
            }
            if (null != e && null != e.line && (false == (typeCast(ChartEmptyFill.$, e.line.fill) !== null))) {
                f.add(this.v(e, "Volume", g, i));
            }
        }
        bh() {
            this.an = true;
            this.be();
            this.bg();
            if (false == this.ai) {
                return;
            }
            this.bi();
            this.ao();
            if (null == this.l) {
                return;
            }
            this.bl();
            if (this.aq && false == this.am) {
                return;
            }
            this.an = false;
            this.by();
            this.bt();
            this.bw();
            this.bx();
            this.a7 = this.aw.count;
        }
        ao(a = true) {
            if (null == this.l || this.aj) {
            }
            else {
                return true;
            }
            if (a) {
                this.l = null;
            }
            switch (this.c.chartType) {
                case 1:
                case 76:
                case 77:
                    if (a) {
                        this.b6();
                        this.l = this.n();
                    }
                    else {
                        return true;
                    }
                    break;
                case -4098: break;
                case 78: break;
                case 79: break;
                case 60: break;
                case 61: break;
                case 62: break;
                case 57:
                case 58:
                case 59:
                    if (a) {
                        this.b6();
                        this.l = this.n();
                    }
                    else {
                        return true;
                    }
                    break;
                case 71: break;
                case 15:
                case 87:
                    if (a) {
                        this.b6();
                        this.l = this.n();
                    }
                    else {
                        return true;
                    }
                    break;
                case -4100: break;
                case 54: break;
                case 55: break;
                case 56: break;
                case 51:
                case 52:
                case 53:
                    if (a) {
                        this.b6();
                        this.l = this.n();
                    }
                    else {
                        return true;
                    }
                    break;
                case 113:
                    if (a) {
                        this.b6();
                        this.l = this.n();
                    }
                    else {
                        return true;
                    }
                    break;
                case 102: break;
                case 103: break;
                case 104: break;
                case 105: break;
                case 99: break;
                case 100: break;
                case 101: break;
                case 95: break;
                case 96: break;
                case 97: break;
                case 98: break;
                case 92: break;
                case 93: break;
                case 94: break;
                case -4120:
                case 80:
                    if (a) {
                        this.b6();
                        this.l = this.o();
                    }
                    else {
                        return true;
                    }
                    break;
                case 4:
                case 63:
                case 64:
                case 65:
                case 66:
                case 67:
                    if (a) {
                        this.b6();
                        this.l = this.n();
                    }
                    else {
                        return true;
                    }
                    break;
                case -4101: break;
                case 5:
                case -4102:
                case 70:
                case 69:
                    if (a) {
                        this.b6();
                        this.l = this.p();
                    }
                    else {
                        return true;
                    }
                    break;
                case 68: break;
                case 109: break;
                case 110: break;
                case 111: break;
                case 112: break;
                case 106: break;
                case 107: break;
                case 108: break;
                case -4151:
                case 82:
                case 81:
                    if (a) {
                        this.b6();
                        this.l = this.n();
                    }
                    else {
                        return true;
                    }
                    break;
                case 88:
                case 89:
                case 90:
                case 91:
                    if (a) {
                        this.b6();
                        this.l = this.r();
                    }
                    else {
                        return true;
                    }
                    break;
                case 83:
                case 84: break;
                case 85:
                case 86: break;
                case -4169:
                case 74:
                case 75:
                case 72:
                case 73:
                    if (a) {
                        this.b6();
                        this.l = this.n();
                    }
                    else {
                        return true;
                    }
                    break;
            }
            if (null == this.l) {
                throw new NotSupportedException(1, this.ae._s("Error_ChartTypeNotSupportedForRendering", EnumUtil.getName(ChartType_$type, this.c.chartType)));
            }
            return true;
        }
        bj() {
            if (false == this.aj) {
                return;
            }
            this.a0 = this.a5();
            let a = new Dictionary$2(String_$type, List$1.$.specialize(SpreadsheetChartAdapter_ScatterSeriesDataItem.$), 0);
            for (let b of fromEnum(this.a0)) {
                let c = b.SeriesName;
                if (a.containsKey(c)) {
                    a.item(c).add(b);
                }
                else {
                    a.item(c, new List$1(SpreadsheetChartAdapter_ScatterSeriesDataItem.$, 0));
                    a.item(c).add(b);
                }
            }
            for (let d = 0; d < a.values.count; d++) {
                let e = stringFormat("groupedscatterseriesdata{0}", d.toString());
                this.ac.g(this.k, this.a8, e, Enumerable.z(List$1.$.specialize(SpreadsheetChartAdapter_ScatterSeriesDataItem.$), a.values)._inner[d].toArray());
            }
            this.ax = Enumerable.z(List$1.$.specialize(SpreadsheetChartAdapter_ScatterSeriesDataItem.$), a.values);
        }
        bk(a = 0) {
            if (false == this.aj) {
                return;
            }
            this.a1 = this.a6();
            let b = new Dictionary$2(String_$type, List$1.$.specialize(SpreadsheetChartAdapter_SeriesDataItem.$), 0);
            for (let c of fromEnum(this.a1)) {
                let d = (a == 0) ? c.Row : c.Col;
                if (b.containsKey(d)) {
                    b.item(d).add(c);
                }
                else {
                    b.item(d, new List$1(SpreadsheetChartAdapter_SeriesDataItem.$, 0));
                    b.item(d).add(c);
                }
            }
            for (let e = 0; e < b.values.count; e++) {
                let f = stringFormat("groupedseriesdata{0}", e.toString());
                this.ac.g(this.k, this.a8, f, Enumerable.z(List$1.$.specialize(SpreadsheetChartAdapter_SeriesDataItem.$), b.values)._inner[e].toArray());
            }
            this.ay = Enumerable.z(List$1.$.specialize(SpreadsheetChartAdapter_SeriesDataItem.$), b.values);
        }
        bi() {
            this.aw = new List$1(ChartSeriesInfo.$, 0);
            let a = new HashSet$1(String_$type, 0);
            let b = 0;
            for (let c of fromEnum(this.c._seriesCollection$i)) {
                if (false == this.au(c)) {
                    let d = SpreadsheetChartAdapterHelpers.v(c, b + 1);
                    let e = d;
                    while (a.contains(e)) {
                        e = d + this.ag.e().toString();
                    }
                    a.add_1(e);
                    let f = SpreadsheetChartAdapterHelpers.w(c, b + 1);
                    this.aw.add(((() => {
                        let $ret = new ChartSeriesInfo();
                        $ret.a = c;
                        $ret.c = e;
                        $ret.d = f;
                        $ret.b = b;
                        return $ret;
                    })()));
                    b++;
                }
            }
        }
        bm() {
            if (false == this.aj) {
                return;
            }
            this.a1 = this.a6();
            let a = new Dictionary$2(String_$type, List$1.$.specialize(SpreadsheetChartAdapter_SeriesDataItem.$), 0);
            for (let b of fromEnum(this.a1)) {
                let c = b.Row;
                if (a.containsKey(c)) {
                    a.item(c).add(b);
                }
                else {
                    a.item(c, new List$1(SpreadsheetChartAdapter_SeriesDataItem.$, 0));
                    a.item(c).add(b);
                }
            }
            let d = Enumerable.z(List$1.$.specialize(SpreadsheetChartAdapter_SeriesDataItem.$), a.values);
            this.az = new List$1(SpreadsheetChartAdapter_PieDataItem.$, 0);
            for (let e of fromEnum(d)) {
                let f = ((() => {
                    let $ret = new SpreadsheetChartAdapter_PieDataItem();
                    $ret.CategoryName = e._inner[0].Row;
                    $ret.Value = e._inner[0].Value;
                    $ret.SeriesName = e._inner[0].Col;
                    return $ret;
                })());
                this.az.add(f);
            }
            this.ac.g(this.k, this.a8, "piedata", this.az.toArray());
        }
        bl() {
            if (null != this.c.legend) {
                if (null != this.m) {
                    return;
                }
            }
            else if (null != this.m) {
                this.m = null;
                return;
            }
            this.bp();
        }
        bn() {
            if (false == this.aj) {
                return;
            }
            this.a2 = new List$1(SpreadsheetChartAdapter_StackedSeriesDataItem.$, 0);
            let a;
            let b;
            let c = this.bq(this.a4._inner[0].a, b, a);
            b = c.p1;
            a = c.p2;
            let d = a.length;
            let e = b.length;
            let f = 0;
            let g = this.a4.count;
            let h = ((() => {
                let $firstRank;
                let $ret = new Array($firstRank = d);
                let $currRet = $ret;
                for (let $rankInit = 0; $rankInit < $firstRank; $rankInit++) {
                    $currRet[$rankInit] = new Array(g);
                }
                return $ret;
            })());
            for (let i = 0; i < d; i++) {
                let j = 0;
                for (let k of fromEnum(this.a4)) {
                    let l;
                    let m;
                    let n = this.bq(k.a, m, l);
                    m = n.p1;
                    l = n.p2;
                    h[f][j] = Convert.toDouble3(m[f]);
                    j++;
                }
                f++;
            }
            f = 0;
            for (let o = 0; o < d; o++) {
                let p = new Array(g);
                let q = new Array(g);
                let r = 0;
                for (let s of fromEnum(this.a4)) {
                    p[r] = Convert.toDouble3(h[f][r]);
                    q[r] = s.c;
                    r++;
                }
                let t = ((() => {
                    let $ret = new SpreadsheetChartAdapter_StackedSeriesDataItem();
                    $ret.CategoryName = a[o].toString();
                    $ret.SeriesValues = p;
                    $ret.SeriesNames = q;
                    return $ret;
                })());
                this.a2.add(t);
                f++;
            }
            this.ac.g(this.k, this.a8, "stackedseriesdata", this.a2.toArray());
        }
        bo() {
            if (false == this.aj) {
                return;
            }
            this.a3 = new List$1(SpreadsheetChartAdapter_StockDataItem.$, 0);
            this.a1 = this.a6();
            let a = this.c.chartType;
            let b = stringEmpty();
            let c = null;
            let d = -1;
            let e = new Dictionary$2(String_$type, SpreadsheetChartAdapter_StockDataItem.$, 0);
            for (let f of fromEnum(this.a1)) {
                if (false == e.containsKey(f.Row)) {
                    c = ((() => {
                        let $ret = new SpreadsheetChartAdapter_StockDataItem();
                        $ret.CategoryName = f.Row;
                        return $ret;
                    })());
                    e.addItem(f.Row, c);
                }
                else {
                    c = e.item(f.Row);
                }
                if (f.Col != b) {
                    d++;
                    b = f.Col;
                }
                c.g(a, d, f.Value);
            }
            for (let g of fromEnum(e.values)) {
                this.a3.add(g);
            }
            this.ac.g(this.k, this.a8, "stockdata", this.a3.toArray());
        }
        n() {
            this.ac.u("datachart");
            DataChartCategoryCoreDescriptionModule.register(this.k.context);
            DataChartCategoryDescriptionModule.register(this.k.context);
            DataChartVerticalCategoryDescriptionModule.register(this.k.context);
            let a = new DataChartDescription();
            let b = new AxisInfos();
            for (let c of fromEnum(this.c._axisCollection$i)) {
                switch (c.type) {
                    case 1:
                        this.bk();
                        if (this.c.chartType == -4151 || this.c.chartType == 81 || this.c.chartType == 82) {
                            b.l(SpreadsheetChartAdapterHelpers.f(c, this.ag));
                        }
                        else {
                            b.l(SpreadsheetChartAdapterHelpers.g(c, this.ag));
                        }
                        break;
                    case 2:
                        if (this.c.chartType == -4151 || this.c.chartType == 81 || this.c.chartType == 82) {
                            b.l(SpreadsheetChartAdapterHelpers.h(c, this.ag));
                        }
                        else {
                            b.l(SpreadsheetChartAdapterHelpers.i(c, this.ag));
                        }
                        break;
                    case 3: break;
                }
            }
            let d = new List$1(SeriesDescription.$, 0);
            let e = 0;
            let f = false;
            let g = 0;
            let h = new Dictionary$2(Series.$, SeriesDescription.$, 0);
            let i = new Dictionary$2(SeriesDescription.$, Series.$, 0);
            for (let j of fromEnum(this.a4)) {
                let k = j.a;
                if (stringContains(EnumUtil.getName(ChartType_$type, k.chartType), "Stacked")) {
                    g++;
                    if (g > 1) {
                        e++;
                        continue;
                    }
                }
                if (this.ar && SpreadsheetChartAdapterHelpers.k(k)) {
                    f = true;
                }
                let l = typeCast(SeriesDescription.$, this.q(k, e, b));
                if (null != l) {
                    d.add(l);
                    h.addItem(k, l);
                    i.addItem(l, k);
                    if (stringContains(EnumUtil.getName(ChartType_$type, k.chartType), "Stacked")) {
                        for (let m of fromEnum(b.b)) {
                            if (m.d) {
                                m.a.label = "CategoryName";
                                m.a.dataSourceRef = "stackedseriesdata";
                            }
                        }
                    }
                }
                else {
                    throw new NotSupportedException(1, this.ae._s("Error_UnsupportedSeriesType", EnumUtil.getName(SeriesType_$type, k.type)));
                }
                e++;
            }
            if (this.ar && f) {
                for (let n of fromEnum(h.keys)) {
                    if (false == SpreadsheetChartAdapterHelpers.k(n)) {
                        let o = h.item(n);
                        if (typeCast(HorizontalAnchoredCategorySeriesDescription.$, o) !== null && o.xAxisRef == "XAxisSecondary") {
                            o.xAxisRef = "XAxisPrimary";
                            o.yAxisRef = "YAxisPrimary";
                        }
                    }
                }
            }
            if (this.al) {
                if (this.a7 != -1 && (this.a7 != this.a4.count)) {
                    a.axes = new Array(0);
                    a.series = new Array(0);
                    this.bw(a);
                }
            }
            this.b4(b);
            this.b7(d);
            a.axes = b.a();
            a.series = Enumerable.a(SeriesDescription.$, d);
            a.shouldAutoExpandMarginForInitialLabels = true;
            a.shouldConsiderAutoRotationForInitialLabels = true;
            a.autoMarginAndAngleUpdateMode = "SizeChanging";
            this.bz(a);
            let p = "GetDVDataChart1";
            return a;
        }
        o() {
            this.ac.u("doughnutchart");
            DoughnutChartDescriptionMetadata.d(this.k.context);
            let a = new DoughnutChartDescription();
            this.bc = "Series '{Col}' Point '{Row}' Value: {Value}";
            this.ac.g(this.k, this.a8, "doughnutcharttooltip", this.bc);
            let b = 0;
            let c = new List$1(RingSeriesDescription.$, 0);
            for (let d of fromEnum(this.a4)) {
                let e = d.a;
                if (null == e.values || e.values.getValues().length < 1) {
                    b++;
                    continue;
                }
                let f = typeCast(RingSeriesDescription.$, this.q(e, b, null));
                if (null != f) {
                    f.startAngle = Math.max(-360, this.c.firstSliceAngle - 90);
                    c.add(f);
                    f.tooltipTemplateRef = "doughnutcharttooltip";
                    f.brushes = SpreadsheetChartAdapterHelpers.b(e, b);
                }
                else {
                    throw new NotSupportedException(1, this.ae._s("Error_UnsupportedSeriesType", EnumUtil.getName(SeriesType_$type, e.type)));
                }
                b++;
            }
            a.innerExtent = this.c.doughnutHoleSize;
            a.series = Enumerable.a(RingSeriesDescription.$, c);
            let g = SpreadsheetChartAdapterHelpers.r(this.c.plotArea._ap, this.ah);
            if (false == stringIsNullOrEmpty(g)) {
                a.background = g;
            }
            else {
                a.background = "rgba(0, 0, 0, 0)";
            }
            return a;
        }
        bp() {
            if (null == this.c.legend) {
                return;
            }
            LegendDescriptionModule.register(this.k.context);
            ItemLegendDescriptionModule.register(this.k.context);
            switch (this.c.chartType) {
                case 5:
                case 71:
                case -4102:
                case 70:
                case 69:
                case 68:
                case -4120:
                case 80:
                    this.m = new ItemLegendDescription();
                    break;
                default:
                    this.m = new LegendDescription();
                    break;
            }
            this.m.name = "legend";
            let a = SpreadsheetChartAdapterHelpers.r(this.c.legend._af, this.ah);
            if (false == stringIsNullOrEmpty(a)) {
                this.m.background = a;
            }
            else {
                this.m.background = "rgba(0, 0, 0, 0)";
            }
        }
        p() {
            this.ac.u("piechart");
            PieChartDescriptionModule.register(this.k.context);
            this.bm();
            let a = new PieChartDescription();
            a.dataSourceRef = "piedata";
            a.valueMemberPath = "Value";
            a.labelMemberPath = "CategoryName";
            a.legendRef = "legend";
            a.startAngle = Math.max(-360, this.c.firstSliceAngle - 90);
            this.bd = "Series '{SeriesName}' Point '{CategoryName}' Value: {Value}";
            this.ac.g(this.k, this.a8, "piecharttooltip", this.bd);
            a.tooltipTemplateRef = "piecharttooltip";
            if (this.a4.count > 0) {
                let b = 0;
                let c = this.a4._inner[b].a;
                a.brushes = SpreadsheetChartAdapterHelpers.b(c, b);
                let d = 0;
                a.explodedSlices = ((() => { let e = SpreadsheetChartAdapterHelpers.a(c, b, d); d = e.p2; return e.ret; })());
                a.explodedRadius = Math.max(d, c.explosion) / 100;
                a.othersCategoryThreshold = -1.7976931348623157E+308;
            }
            let e = SpreadsheetChartAdapterHelpers.r(this.c.plotArea._ap, this.ah);
            if (false == stringIsNullOrEmpty(e)) {
                a.background = e;
            }
            else {
                a.background = "rgba(0, 0, 0, 0)";
            }
            return a;
        }
        q(a, b, c) {
            switch (a.type) {
                case 0:
                case 2:
                case 1: return this.z(a, b);
                case 3: return this.u(a, b);
                case 4: return this.aa(a, b, c);
                case 6:
                case 7: return this.ab(a, b, c);
                case 5: break;
            }
            return null;
        }
        r() {
            if (!this.at) {
                return null;
            }
            this.ac.u("datachart");
            DataChartFinancialDescriptionModule.register(this.k.context);
            DataChartCategoryDescriptionModule.register(this.k.context);
            let a = null;
            this.bo();
            switch (this.c.chartType) {
                case 88:
                    {
                        if (false == this.av(1, 1, 0)) {
                            throw new NotSupportedException(1, this.ae._s("Error_InvalidAxesCountOrTypeForChartType", EnumUtil.getName(ChartType_$type, this.c.chartType)));
                        }
                        a = new DataChartDescription();
                        let b = this.j(SpreadsheetChartAdapterHelpers.j(0, this.c._axisCollection$i, this.ag));
                        let c = this.s(SpreadsheetChartAdapterHelpers.j(1, this.c._axisCollection$i, this.ag));
                        a.axes = [b, c];
                        let d = new List$1(SeriesDescription.$, 0);
                        d.add(this.w(b.name, c.name));
                        let e = this.a4.count > 0 ? this.a4._inner[0].a : null;
                        let f = this.a4.count > 1 ? this.a4._inner[1].a : null;
                        let g = this.a4.count > 2 ? this.a4._inner[2].a : null;
                        this.bf(e, f, g, null, null, d, b.name, c.name);
                        a.series = Enumerable.a(SeriesDescription.$, d);
                        break;
                    }
                case 89:
                    {
                        if (false == this.av(1, 1, 0)) {
                            throw new NotSupportedException(1, this.ae._s("Error_InvalidAxesCountOrTypeForChartType", EnumUtil.getName(ChartType_$type, this.c.chartType)));
                        }
                        a = new DataChartDescription();
                        let h = this.j(SpreadsheetChartAdapterHelpers.j(0, this.c._axisCollection$i, this.ag));
                        let i = this.s(SpreadsheetChartAdapterHelpers.j(1, this.c._axisCollection$i, this.ag));
                        a.axes = [h, i];
                        let j = new List$1(SeriesDescription.$, 0);
                        j.add(this.x(h.name, i.name));
                        let k = this.a4.count > 0 ? this.a4._inner[0].a : null;
                        let l = this.a4.count > 1 ? this.a4._inner[1].a : null;
                        let m = this.a4.count > 2 ? this.a4._inner[2].a : null;
                        let n = this.a4.count > 3 ? this.a4._inner[3].a : null;
                        this.bf(l, m, n, k, null, j, h.name, i.name);
                        a.series = Enumerable.a(SeriesDescription.$, j);
                        break;
                    }
                case 90:
                    {
                        if (false == this.av(1, 1, 1)) {
                            throw new NotSupportedException(1, this.ae._s("Error_InvalidAxesCountOrTypeForChartType", EnumUtil.getName(ChartType_$type, this.c.chartType)));
                        }
                        a = new DataChartDescription();
                        let o = this.j(SpreadsheetChartAdapterHelpers.j(0, this.c._axisCollection$i, this.ag));
                        let p = this.s(SpreadsheetChartAdapterHelpers.j(1, this.c._axisCollection$i, this.ag));
                        let q = this.t(SpreadsheetChartAdapterHelpers.j(3, this.c._axisCollection$i, this.ag));
                        a.axes = [o, p, q];
                        let r = this.a4.count > 0 ? this.a4._inner[0].a : null;
                        let s = this.a4.count > 1 ? this.a4._inner[1].a : null;
                        let t = this.a4.count > 2 ? this.a4._inner[2].a : null;
                        let u = this.a4.count > 3 ? this.a4._inner[3].a : null;
                        let v = new List$1(SeriesDescription.$, 0);
                        v.add(this.y(r, o.name, q.name));
                        v.add(this.w(o.name, p.name));
                        this.bf(s, t, u, null, r, v, o.name, p.name, q.name);
                        a.series = Enumerable.a(SeriesDescription.$, v);
                        break;
                    }
                case 91:
                    {
                        if (false == this.av(1, 1, 1)) {
                            throw new NotSupportedException(1, this.ae._s("Error_InvalidAxesCountOrTypeForChartType", EnumUtil.getName(ChartType_$type, this.c.chartType)));
                        }
                        a = new DataChartDescription();
                        let w = this.j(SpreadsheetChartAdapterHelpers.j(0, this.c._axisCollection$i, this.ag));
                        let x = this.s(SpreadsheetChartAdapterHelpers.j(1, this.c._axisCollection$i, this.ag));
                        let y = this.t(SpreadsheetChartAdapterHelpers.j(3, this.c._axisCollection$i, this.ag));
                        a.axes = [w, x, y];
                        let z = this.a4.count > 0 ? this.a4._inner[0].a : null;
                        let aa = this.a4.count > 1 ? this.a4._inner[1].a : null;
                        let ab = this.a4.count > 2 ? this.a4._inner[2].a : null;
                        let ac = this.a4.count > 3 ? this.a4._inner[3].a : null;
                        let ad = this.a4.count > 4 ? this.a4._inner[4].a : null;
                        let ae = new List$1(SeriesDescription.$, 0);
                        ae.add(this.y(z, w.name, y.name));
                        ae.add(this.x(w.name, x.name));
                        this.bf(ab, ac, ad, aa, z, ae, w.name, x.name, y.name);
                        a.series = Enumerable.a(SeriesDescription.$, ae);
                        break;
                    }
                default: break;
            }
            if (null != a) {
                this.bz(a);
            }
            return a;
        }
        j(a) {
            let b = new CategoryXAxisDescription();
            b.name = "XAxis";
            b.label = "CategoryName";
            b.dataSourceRef = "stockdata";
            b.tickLength = 10;
            b.gap = 0.35;
            SpreadsheetChartAdapterHelpers.x(b, a, this.ag);
            b.useClusteringMode = true;
            return b;
        }
        s(a) {
            let b = new NumericYAxisDescription();
            b.name = "Prices";
            b.minimumValue = 0;
            b.abbreviateLargeNumbers = true;
            SpreadsheetChartAdapterHelpers.x(b, a, this.ag);
            if (a.visible) {
                let c = "formatlabelstockchartaxis_" + b.name;
                this.ac.v(this.ag.a, this.ag.f, c, (d, e) => {
                    if (typeof e === 'number') {
                        let f = e;
                        let g = a._y();
                        if (null != g) {
                            let h = stringEmpty();
                            if (((() => { let i = g.v(f, a.tickLabels.numberFormat, h); h = i.p2; return i.ret; })())) {
                                return h;
                            }
                        }
                    }
                    return e.toString();
                });
                b.formatLabelRef = c;
            }
            else {
                b.formatLabelRef = stringEmpty();
            }
            return b;
        }
        t(a) {
            let b = new NumericYAxisDescription();
            b.name = "Volume";
            b.minimumValue = 0;
            b.abbreviateLargeNumbers = true;
            SpreadsheetChartAdapterHelpers.x(b, a, this.ag);
            return b;
        }
        v(a, b, c, d) {
            let e = new LineSeriesDescription();
            e.showDefaultTooltip = true;
            this.b1(e, a);
            e.title = b;
            e.thickness = 1;
            e.xAxisRef = c;
            e.yAxisRef = d;
            e.dataSourceRef = "stockdata";
            e.valueMemberPath = b;
            return e;
        }
        y(a, b, c) {
            let d = new ColumnSeriesDescription();
            d.showDefaultTooltip = true;
            this.b1(d, a);
            d.title = "Volume";
            d.thickness = 1;
            d.xAxisRef = b;
            d.yAxisRef = c;
            d.dataSourceRef = "stockdata";
            d.valueMemberPath = "Volume";
            return d;
        }
        x(a, b) {
            let c = new FinancialPriceSeriesDescription();
            c.displayType = EnumUtil.getName(PriceDisplayType_$type, (0));
            c.showDefaultTooltip = true;
            this.b2(c);
            c.title = "Open High Low Close";
            c.thickness = 1;
            c.xAxisRef = a;
            c.yAxisRef = b;
            c.dataSourceRef = "stockdata";
            c.highMemberPath = "High";
            c.lowMemberPath = "Low";
            c.openMemberPath = "Open";
            c.closeMemberPath = "Close";
            return c;
        }
        w(a, b) {
            let c = new FinancialPriceSeriesDescription();
            c.displayType = EnumUtil.getName(PriceDisplayType_$type, (1));
            this.b2(c);
            c.title = "High Low Close";
            c.xAxisRef = a;
            c.yAxisRef = b;
            c.dataSourceRef = "stockdata";
            c.highMemberPath = "High";
            c.lowMemberPath = "Low";
            c.openMemberPath = "Open";
            c.closeMemberPath = "Close";
            c.showDefaultTooltip = true;
            return c;
        }
        ap(a) {
            if (null == a.bubbleSizes) {
                return false;
            }
            let b = a.bubbleSizes.getValues();
            for (let d = 0; d < b.length; d++) {
                let c = b[d];
                if (null == c || false == (typeof c === 'number' || typeof c === 'number')) {
                    return false;
                }
            }
            return true;
        }
        a5() {
            if (null != this.a0) {
                return this.a0;
            }
            this.a0 = new List$1(SpreadsheetChartAdapter_ScatterSeriesDataItem.$, 0);
            let a = 0;
            for (let b of fromEnum(this.a4)) {
                let c = b.a;
                this.br(c);
                let d;
                let e;
                let f = this.bq(c, e, d, true);
                e = f.p1;
                d = f.p2;
                let g = this.ap(c);
                let h = null;
                if (g) {
                    h = c.bubbleSizes.getValues();
                }
                let i = b.c;
                for (let j = 0; j < e.length; j++) {
                    let k = (typeof e[j] === 'number') ? e[j] : typeGetValue(e[j]);
                    let l = (typeof d[j] === 'number') ? d[j] : typeGetValue(d[j]);
                    let m = 0;
                    if (g) {
                        m = (typeof h[j] === 'number') ? h[j] : typeGetValue(h[j]);
                    }
                    this.a0.add(new SpreadsheetChartAdapter_ScatterSeriesDataItem(l, k, m, i));
                }
                a++;
            }
            return this.a0;
        }
        a6() {
            if (null != this.a1) {
                return this.a1;
            }
            this.a1 = new List$1(SpreadsheetChartAdapter_SeriesDataItem.$, 0);
            let a = 0;
            for (let b of fromEnum(this.a4)) {
                let c = b.a;
                this.br(c);
                let d;
                let e;
                let f = this.bq(c, e, d);
                e = f.p1;
                d = f.p2;
                for (let g = 0; g < e.length; g++) {
                    let h = b.c;
                    let i = (typeof e[g] === 'number') ? e[g] : typeGetValue(e[g]);
                    let j = g < d.length ? d[g] : null;
                    let k = (null == j) ? "" : j.toString();
                    this.a1.add(((() => {
                        let $ret = new SpreadsheetChartAdapter_SeriesDataItem();
                        $ret.Row = k;
                        $ret.Col = h;
                        $ret.Value = i;
                        return $ret;
                    })()));
                }
                a++;
            }
            return this.a1;
        }
        bq(a, b, c, d = false) {
            let e;
            let f;
            let g = a._dn(e, f);
            e = g.p0;
            f = g.p1;
            let h = e.length;
            for (let i = 0; i < h; i++) {
                let j = e[i];
                if (typeof j === 'number' || typeof j === 'number') {
                    e[i] = j;
                }
                else {
                    e[i] = 0;
                }
            }
            h = f.length;
            for (let k = 0; k < h; k++) {
                let l = f[k];
                if (d) {
                    if (typeof l === 'number' || typeof l === 'number') {
                        f[k] = l;
                    }
                    else {
                        f[k] = k + 1;
                    }
                }
                else {
                    if (null == l || typeof l === 'string' && stringIsNullOrEmpty(l)) {
                        f[k] = k;
                    }
                    else {
                        f[k] = l;
                    }
                }
            }
            b = e;
            c = f;
            return {
                p1: b,
                p2: c
            };
        }
        br(a) {
        }
        bs() {
            if (null != this.a8 && false == this.ai) {
                this.ai = this.ac.e(this.a8);
            }
            if (null != this.bb && false == this.am) {
                this.am = this.ac.e(this.bb);
            }
            if (this.an) {
                this.bh();
            }
        }
        bt() {
            let a = 0;
            let b = 0;
            let c = 1;
            let d = 1;
            let e = 0;
            let f = 0;
            let g = 1;
            let h = 1;
            let i = 0;
            let j = false;
            let k = this.c.legend;
            let l = null != k ? k.position : 6;
            this.ac.t(this.f);
            if (null != this.bb) {
                this.ac.h(this.bb, this.a8);
            }
            let m = () => l == 1;
            let n = () => l == 2 || l == 4;
            let o = () => l == 3;
            let p = () => l == 0;
            if (o()) {
                l = 1;
            }
            else if (p()) {
                l = 2;
            }
            let q = new List$1(RowColLength.$, 0);
            let r = new List$1(RowColLength.$, 0);
            q.add(RowColLength.a);
            i++;
            if (o() && this.aq && false == j) {
                q.add(RowColLength.a);
                i++;
            }
            q.add(new RowColLength(2, 1, 2));
            if (p() && this.aq && false == j) {
                q.add(RowColLength.a);
            }
            if (m() && this.aq && false == j) {
                r.add(RowColLength.a);
            }
            r.add(new RowColLength(2, 1, 2));
            if (n() && this.aq && false == j) {
                r.add(RowColLength.a);
            }
            this.ac.k(this.f, Enumerable.a(RowColLength.$, q), Enumerable.a(RowColLength.$, r));
            if (this.aq) {
                switch (l) {
                    case 3:
                        e = i - 1;
                        g = 1;
                        f = 0;
                        h = 1;
                        break;
                    case 0:
                    case 5:
                    case 6:
                        e = false == j ? 2 : 1;
                        g = 1;
                        f = 0;
                        h = 1;
                        break;
                    case 1:
                        e = i;
                        g = 1;
                        f = 0;
                        h = 1;
                        break;
                    case 2:
                    case 4:
                        e = i;
                        g = 1;
                        f = false == j ? 1 : 0;
                        h = 1;
                        break;
                }
            }
            a = 0;
            c = 1;
            b = 0;
            d = 2;
            this.ac.s(this.f, this.a8, 5, true, i, this.aq && m() && false == j ? 1 : 0);
            if (this.aq) {
                if (j) {
                    let s = 0;
                    switch (l) {
                        case 3:
                            s = 1;
                            break;
                        case 0:
                        case 5:
                        case 6:
                            s = 2;
                            break;
                        case 1:
                            s = 3;
                            break;
                        case 2:
                        case 4:
                            s = 4;
                            break;
                    }
                    this.ac.c(this.bb, this.a8, s, true);
                }
                else {
                    let t = 1;
                    let u = 0;
                    let v = 1;
                    switch (l) {
                        case 3:
                            t = 5;
                            break;
                        case 0:
                        case 5:
                            t = 5;
                            break;
                        case 1:
                            t = 0;
                            u = 4 | 8;
                            break;
                        case 2:
                            t = 0;
                            u = 4 | 8;
                            break;
                        case 4:
                            t = 0;
                            u = 4 | 8 | 1;
                            v = 0;
                            break;
                    }
                    this.ac.s(this.f, this.bb, t, true, e, f, g, h, 3, v, u);
                }
            }
            if (null != this.c.chartTitle) {
                if (null != this.ad) {
                    if (null == this.ba) {
                        this.ba = this.ac.n();
                    }
                    let w = (null != this.ba);
                    if (null == this.a9) {
                        this.a9 = this.ad(this.c, null);
                        if (w) {
                            this.ac.c(this.a9, this.ba, 0);
                        }
                    }
                    else {
                        this.a9 = this.ad(this.c, this.a9);
                    }
                    if (w) {
                        this.ac.s(this.f, this.ba, 5, true, a, b, c, d);
                    }
                    else {
                        this.ac.s(this.f, this.a9, 5, true, a, b, c, d, 1, 3);
                    }
                }
            }
        }
        bu() {
            if (null != this.ay) {
                this.ay.clear();
                this.ay = null;
            }
            if (null != this.ax) {
                this.ax.clear();
                this.ax = null;
            }
            if (null != this.a2) {
                this.a2.clear();
                this.a2 = null;
            }
            if (null != this.az) {
                this.az.clear();
                this.az = null;
            }
            if (null != this.a1) {
                this.a1.clear();
                this.a1 = null;
            }
            if (null != this.a0) {
                this.a0.clear();
                this.a0 = null;
            }
            if (null != this.a3) {
                this.a3.clear();
                this.a3 = null;
            }
            if (null != this.a8) {
                this.ac.d(this.k, this.a8);
            }
            if (null != this.bb) {
                this.ac.d(this.k, this.bb);
            }
            this.aj = true;
        }
        bv() {
            this.l = null;
            this.m = null;
            this.ak = true;
        }
        bw(a = null) {
            let b = (null == a) ? this.l : a;
            if (null == b) {
                return;
            }
            if (null == this.a8) {
                return;
            }
            this.ac.x(this.k, b, this.a8);
        }
        bx() {
            if (null != this.m) {
                this.ac.x(this.k, this.m, this.bb);
            }
        }
        by() {
            if (false == this.aq) {
                if (typeCast(SeriesViewerDescription.$, this.l) !== null) {
                    this.l.legendRef = null;
                }
                return;
            }
            if (typeCast(SeriesViewerDescription.$, this.l) !== null) {
                this.l.legendRef = "legend";
            }
        }
        bz(a) {
            a.background = "rgba(0, 0, 0, 0)";
            let b = SpreadsheetChartAdapterHelpers.r(this.c.plotArea._ap, this.ah);
            if (false == stringIsNullOrEmpty(b)) {
                a.plotAreaBackground = b;
            }
            else {
                b = SpreadsheetChartAdapterHelpers.r(this.c.chartArea._ap, this.ah);
                if (false == stringIsNullOrEmpty(b)) {
                    a.plotAreaBackground = b;
                }
            }
        }
        b0(a, b) {
            if (!(typeCast(MarkerSeriesDescription.$, a) !== null || typeCast(StackedFragmentSeriesDescription.$, a) !== null)) {
                return;
            }
            let c = 1;
            if (typeCast(BubbleSeriesDescription.$, a) !== null) {
                c = 3;
            }
            else {
                switch (b.markerStyle) {
                    case -4105:
                        c = 2;
                        break;
                    case 8:
                        c = 3;
                        break;
                    case -4115:
                        c = 6;
                        break;
                    case 2:
                        c = 7;
                        break;
                    case -4118:
                        c = 3;
                        break;
                    case -4142:
                        c = 1;
                        break;
                    case -4147:
                        c = 3;
                        break;
                    case 9:
                        c = 10;
                        break;
                    case 1:
                        c = 6;
                        break;
                    case 5:
                        c = 11;
                        break;
                    case 3:
                        c = 4;
                        break;
                    case -4168:
                        c = 4;
                        break;
                }
            }
            if (c == 2) {
                if (typeCast(BubbleSeriesDescription.$, a) !== null && b.chartType == 87) {
                    a.markerBrush = "rgba(0,162,232,1)";
                    a.markerOutline = "rgba(0, 0, 0, 0)";
                    return;
                }
            }
            let d = Enumerable.af(ChartSeriesInfo.$, Enumerable.u(ChartSeriesInfo.$, this.a4, (e) => e.a == b)).b;
            if (typeCast(MarkerSeriesDescription.$, a) !== null) {
                a.markerType = EnumUtil.getName(MarkerType_$type, c);
                let e = SpreadsheetChartAdapterHelpers.r(b._ar(d), this.ah);
                if (false == stringIsNullOrEmpty(e)) {
                    a.markerBrush = e;
                }
                if (null != b.markerBorder) {
                    e = SpreadsheetChartAdapterHelpers.r(b.markerBorder._ap, this.ah);
                    if (false == stringIsNullOrEmpty(e)) {
                        a.markerOutline = e;
                    }
                }
            }
            else if (typeCast(StackedFragmentSeriesDescription.$, a) !== null) {
                a.markerType = EnumUtil.getName(MarkerType_$type, c);
                let f = SpreadsheetChartAdapterHelpers.r(b._ar(d), this.ah);
                if (false == stringIsNullOrEmpty(f)) {
                    a.markerBrush = f;
                }
                if (null != b.markerBorder) {
                    f = SpreadsheetChartAdapterHelpers.r(b.markerBorder._ap, this.ah);
                    if (false == stringIsNullOrEmpty(f)) {
                        a.markerOutline = f;
                    }
                }
            }
        }
        b1(a, b) {
            let c = Enumerable.af(ChartSeriesInfo.$, Enumerable.u(ChartSeriesInfo.$, this.a4, (d) => d.a == b));
            if (null == c) {
                return;
            }
            let d = c.b;
            let e = typeCast(StackedSeriesBaseDescription.$, a) !== null;
            if (false == e) {
                if (2 == b.type) {
                    if (null != b.line) {
                        let f = SpreadsheetChartAdapterHelpers.r(b._aq(d), this.ah);
                        if (false == stringIsNullOrEmpty(f)) {
                            a.brush = f;
                        }
                    }
                }
                else {
                    let g = SpreadsheetChartAdapterHelpers.r(b._ao(d), this.ah);
                    if (false == stringIsNullOrEmpty(g)) {
                        a.brush = g;
                    }
                }
            }
            if (null != b.border) {
                let h = SpreadsheetChartAdapterHelpers.r(b.border._ap, this.ah);
                if (false == stringIsNullOrEmpty(h)) {
                    a.outline = h;
                }
                else {
                    a.outline = "rgba(0, 0, 0, 0)";
                }
                a.thickness = SpreadsheetChartAdapterHelpers.n(b.border.widthInPoints, this.ah, false);
            }
            else {
                a.outline = "rgba(0, 0, 0, 0)";
            }
            if (null != b.line) {
                a.thickness = SpreadsheetChartAdapterHelpers.n(b.line.widthInPoints, this.c.worksheet.workbook, false);
            }
            if (false == e) {
                this.b0(a, b);
            }
            if (null != b._trendlineCollection$i && b._trendlineCollection$i.count > 0) {
                let i = b._trendlineCollection$i.item(0);
                let j = EnumUtil.getName(TrendLineType_$type, SpreadsheetChartAdapterHelpers.e(i.trendlineType, i.order));
                let k = i.period;
                let l = SpreadsheetChartAdapterHelpers.r(i.line._as(d), this.ah);
                let m = SpreadsheetChartAdapterHelpers.n(i.line.widthInPoints, this.ah, false);
                if (typeCast(AnchoredCategorySeriesDescription.$, a) !== null) {
                    a.trendLineType = j;
                    a.trendLinePeriod = k;
                    a.trendLineBrush = l;
                    a.trendLineThickness = m;
                }
                else if (typeCast(ScatterBaseDescription.$, a) !== null) {
                    a.trendLineType = j;
                    a.trendLinePeriod = k;
                    a.trendLineBrush = l;
                    a.trendLineThickness = m;
                }
                else if (typeCast(PolarBaseDescription.$, a) !== null) {
                    a.trendLineType = j;
                    a.trendLinePeriod = k;
                    a.trendLineBrush = l;
                    a.trendLineThickness = m;
                }
            }
        }
        z(a, b) {
            DataChartCategoryCoreDescriptionModule.register(this.k.context);
            DataChartCategoryDescriptionModule.register(this.k.context);
            DataChartVerticalCategoryDescriptionModule.register(this.k.context);
            let c = null;
            switch (a.chartType) {
                case 52:
                    c = new StackedColumnSeriesDescription();
                    break;
                case 53:
                    c = new Stacked100ColumnSeriesDescription();
                    break;
                case 51:
                    c = new ColumnSeriesDescription();
                    break;
                case 58:
                    c = new StackedBarSeriesDescription();
                    break;
                case 59:
                    c = new Stacked100BarSeriesDescription();
                    break;
                case 57:
                    c = new BarSeriesDescription();
                    break;
                case 4:
                case 65:
                    c = new LineSeriesDescription();
                    break;
                case 63:
                case 66:
                    c = new StackedLineSeriesDescription();
                    break;
                case 64:
                case 67:
                    c = new Stacked100LineSeriesDescription();
                    break;
                case 1:
                    c = new AreaSeriesDescription();
                    break;
                case 76:
                    c = new StackedAreaSeriesDescription();
                    break;
                case 77:
                    c = new Stacked100AreaSeriesDescription();
                    break;
            }
            if (typeCast(StackedSeriesBaseDescription.$, c) !== null) {
                this.b3(typeCast(StackedSeriesBaseDescription.$, c));
                if (typeCast(HorizontalStackedSeriesBaseDescription.$, c) !== null) {
                    c.xAxisRef = a.axisGroup == 1 ? "XAxisPrimary" : "XAxisSecondary";
                    c.yAxisRef = a.axisGroup == 1 ? "YAxisPrimary" : "YAxisSecondary";
                }
                else if (typeCast(VerticalStackedSeriesBaseDescription.$, c) !== null) {
                    c.xAxisRef = a.axisGroup == 1 ? "XAxisPrimary" : "XAxisSecondary";
                    c.yAxisRef = a.axisGroup == 1 ? "YAxisPrimary" : "YAxisSecondary";
                }
            }
            else {
                this.bk(1);
                c.dataSourceRef = stringFormat("groupedseriesdata{0}", b);
                this.b1(c, a);
                if (typeCast(VerticalAnchoredCategorySeriesDescription.$, c) !== null) {
                    c.xAxisRef = a.axisGroup == 1 ? "XAxisPrimary" : "XAxisSecondary";
                    c.yAxisRef = a.axisGroup == 1 ? "YAxisPrimary" : "YAxisSecondary";
                }
                else if (typeCast(HorizontalAnchoredCategorySeriesDescription.$, c) !== null) {
                    c.xAxisRef = a.axisGroup == 1 ? "XAxisPrimary" : "XAxisSecondary";
                    c.yAxisRef = a.axisGroup == 1 ? "YAxisPrimary" : "YAxisSecondary";
                }
                c.valueMemberPath = "Value";
            }
            let d = Enumerable.af(ChartSeriesInfo.$, Enumerable.u(ChartSeriesInfo.$, this.a4, (e) => e.a == a));
            c.name = d.c;
            c.title = d.d;
            c.showDefaultTooltip = true;
            return c;
        }
        b2(a) {
            if (null != this.c.upDownBars) {
                a.brush = SpreadsheetChartAdapterHelpers.r(this.c.upDownBars.upBar._ad, this.ah);
                a.outline = SpreadsheetChartAdapterHelpers.r(this.c.upDownBars.upBar.border._ap, this.ah);
                a.negativeBrush = SpreadsheetChartAdapterHelpers.r(this.c.upDownBars.downBar._ad, this.ah);
                a.negativeOutline = SpreadsheetChartAdapterHelpers.r(this.c.upDownBars.downBar.border._ap, this.ah);
            }
        }
        u(a, b) {
            RingSeriesBaseDescriptionMetadata.d(this.k.context);
            RingSeriesDescriptionMetadata.d(this.k.context);
            HierarchicalRingSeriesDescriptionMetadata.d(this.k.context);
            this.bk(1);
            let c = new RingSeriesDescription();
            c.valueMemberPath = "Value";
            c.labelMemberPath = "Row";
            c.dataSourceRef = stringFormat("groupedseriesdata{0}", b);
            c.tooltipTemplateRef = "doughnutcharttooltip";
            c.brushes = SpreadsheetChartAdapterHelpers.b(a, b);
            if (b == 0) {
                c.legendRef = "legend";
            }
            return c;
        }
        aa(a, b, c) {
            DataChartCategoryCoreDescriptionModule.register(this.k.context);
            DataChartCategoryDescriptionModule.register(this.k.context);
            DataChartVerticalCategoryDescriptionModule.register(this.k.context);
            DataChartRadialCoreDescriptionModule.register(this.k.context);
            DataChartRadialDescriptionModule.register(this.k.context);
            let d = null;
            switch (a.chartType) {
                case -4151:
                case 81:
                    d = new RadialLineSeriesDescription();
                    break;
                case 82:
                    d = new RadialAreaSeriesDescription();
                    break;
            }
            this.bk(1);
            d.dataSourceRef = stringFormat("groupedseriesdata{0}", b);
            this.b1(d, a);
            d.angleAxisRef = "CategoryAngleAxis";
            d.valueAxisRef = "NumericRadiusAxis";
            d.valueMemberPath = "Value";
            let e = Enumerable.af(ChartSeriesInfo.$, Enumerable.u(ChartSeriesInfo.$, this.a4, (f) => f.a == a));
            d.name = e.c;
            d.title = e.d;
            d.showDefaultTooltip = true;
            if (this.ar) {
                c.m(a.axisGroup == 1, this.ag);
            }
            return d;
        }
        ab(a, b, c) {
            DataChartScatterDescriptionModule.register(this.k.context);
            this.bj();
            let d = null;
            let e = a.chartType;
            if (7 == a.type) {
                d = new BubbleSeriesDescription();
            }
            else {
                switch (e) {
                    case -4169:
                        d = new ScatterSeriesDescription();
                        break;
                    case 74:
                    case 75:
                        d = new ScatterLineSeriesDescription();
                        break;
                    case 72:
                    case 73:
                        d = new ScatterSplineSeriesDescription();
                        break;
                }
            }
            d.showDefaultTooltip = true;
            this.b1(d, a);
            d.name = Enumerable.af(ChartSeriesInfo.$, Enumerable.u(ChartSeriesInfo.$, this.a4, (f) => f.a == a)).c;
            d.title = Enumerable.af(ChartSeriesInfo.$, Enumerable.u(ChartSeriesInfo.$, this.a4, (f) => f.a == a)).d;
            if (this.ar) {
                d.xAxisRef = a.axisGroup == 1 ? "XAxisPrimary" : "XAxisSecondary";
                d.yAxisRef = a.axisGroup == 1 ? "YAxisPrimary" : "YAxisSecondary";
            }
            else {
                d.xAxisRef = "XAxisPrimary";
                d.yAxisRef = "YAxisSecondary";
            }
            d.dataSourceRef = stringFormat("groupedscatterseriesdata{0}", b);
            d.yMemberPath = "Y";
            d.xMemberPath = "X";
            if (7 == a.type) {
                let f = null != a.bubbleSizes && a.bubbleSizes.getValues().length != 0;
                if (f) {
                    d.radiusMemberPath = "Radius";
                }
            }
            if (this.ar) {
                c.n(a.axisGroup == 1, this.ag);
            }
            let g = SpreadsheetChartAdapterHelpers.r(a._aq(b), this.ah);
            if (false == stringIsNullOrEmpty(g)) {
                d.brush = g;
            }
            g = SpreadsheetChartAdapterHelpers.r(a._ar(b), this.ah);
            if (false == stringIsNullOrEmpty(g)) {
                d.markerBrush = g;
            }
            return d;
        }
        b3(a) {
            DataChartStackedDescriptionModule.register(this.k.context);
            this.bn();
            let b = this.a4.count;
            let c = new List$1(StackedFragmentSeriesDescription.$, 0);
            for (let d = 0; d < b; d++) {
                let e = this.a4._inner[d].a;
                if (false == stringContains(EnumUtil.getName(ChartType_$type, e.chartType), "Stacked")) {
                    continue;
                }
                let f = new StackedFragmentSeriesDescription();
                f.valueMemberPath = stringFormat("SeriesValues[{0}]", d.toString());
                if (2 == e.type) {
                    if (null != e.line) {
                        let g = SpreadsheetChartAdapterHelpers.r(e._aq(d), this.ah);
                        if (false == stringIsNullOrEmpty(g)) {
                            f.brush = g;
                        }
                    }
                }
                else {
                    let h = SpreadsheetChartAdapterHelpers.r(e._ao(d), this.ah);
                    if (false == stringIsNullOrEmpty(h)) {
                        f.brush = h;
                    }
                }
                if (null != e.border) {
                    let i = SpreadsheetChartAdapterHelpers.r(e.border._ap, this.ah);
                    if (false == stringIsNullOrEmpty(i)) {
                        f.outline = i;
                    }
                    else {
                        f.outline = "rgba(0, 0, 0, 0)";
                    }
                    f.thickness = SpreadsheetChartAdapterHelpers.n(e.border.widthInPoints, this.ah, false);
                }
                else {
                    f.outline = "rgba(0, 0, 0, 0)";
                }
                this.b0(f, e);
                f.name = SpreadsheetChartAdapterHelpers.v(e, d + 1) + "_stacked";
                f.title = SpreadsheetChartAdapterHelpers.w(e, d + 1);
                c.add(f);
            }
            a.dataSourceRef = "stackedseriesdata";
            this.b8(c);
            a.series = Enumerable.a(StackedFragmentSeriesDescription.$, c);
        }
        au(a) {
            let b;
            let c;
            let d = this.bq(a, c, b);
            c = d.p1;
            b = d.p2;
            if (null == c || c.length < 1) {
                return true;
            }
            if (null == a.values) {
                return true;
            }
            let e = true;
            c = a.values.getValues();
            for (let g = 0; g < c.length; g++) {
                let f = c[g];
                if (null != f) {
                    e = false;
                    break;
                }
            }
            return e;
        }
        b4(a) {
            for (let b of fromEnum(a.b)) {
                b.a.rangeChangedRef = stringEmpty();
            }
            if (a.f.count < 1 && a.g.count < 1) {
                return;
            }
            let c = (d) => {
                for (let e of fromEnum(d)) {
                    if (null == e.b.majorGridLines) {
                        return false;
                    }
                }
                return true;
            };
            for (let d = 0; d < 2; d++) {
                let e = null;
                let f = stringEmpty();
                if (d == 0) {
                    e = a.f;
                    if (e.count > 1 && c(e)) {
                        f = "syncrange_xaxis";
                    }
                    else {
                        continue;
                    }
                }
                else {
                    e = a.g;
                    if (e.count > 1 && c(e)) {
                        f = "syncrange_yaxis";
                    }
                    else {
                        continue;
                    }
                }
                e._inner[0].a.rangeChangedRef = f;
                e._inner[1].a.rangeChangedRef = f;
                let g = (h, i) => {
                    let j = truncate(Math.floor(log10(h)));
                    let k = h / Math.pow(10, j);
                    if (i) {
                        let l = k < 1.5 ? 1 : k < 3 ? 2 : k < 7 ? 5 : 10;
                        return l * Math.pow(10, j);
                    }
                    else {
                        let m = k <= 1 ? 1 : k <= 2 ? 2 : k <= 5 ? 5 : 10;
                        return m * Math.pow(10, j);
                    }
                };
                this.ac.w(this.k, this.a8, f, g);
            }
        }
        b5(a, b, c) {
            let d = new Dictionary$2(String_$type, Number_$type, 0);
            let e = new Dictionary$2(String_$type, Number_$type, 0);
            for (let f of fromEnum(b)) {
                let g = stringEmpty();
                let h = stringEmpty();
                if (typeCast(StackedSeriesBaseDescription.$, f) !== null) {
                    if (typeCast(HorizontalStackedSeriesBaseDescription.$, f) !== null) {
                        g = f.xAxisRef;
                        h = f.yAxisRef;
                    }
                    else if (typeCast(VerticalStackedSeriesBaseDescription.$, f) !== null) {
                        g = f.xAxisRef;
                        h = f.yAxisRef;
                    }
                }
                else if (typeCast(ScatterBaseDescription.$, f) !== null) {
                    g = f.xAxisRef;
                    h = f.yAxisRef;
                }
                else {
                    if (typeCast(VerticalAnchoredCategorySeriesDescription.$, f) !== null) {
                        g = f.xAxisRef;
                        h = f.yAxisRef;
                    }
                    else if (typeCast(HorizontalAnchoredCategorySeriesDescription.$, f) !== null) {
                        g = f.xAxisRef;
                        h = f.yAxisRef;
                    }
                }
                if (false == d.containsKey(g)) {
                    d.addItem(g, 1.7976931348623157E+308);
                }
                if (false == d.containsKey(h)) {
                    d.addItem(h, 1.7976931348623157E+308);
                }
                if (false == e.containsKey(g)) {
                    e.addItem(g, -1.7976931348623157E+308);
                }
                if (false == e.containsKey(h)) {
                    e.addItem(h, -1.7976931348623157E+308);
                }
                let i = c.item(f);
                let j = 1.7976931348623157E+308;
                let k = -1.7976931348623157E+308;
                let l;
                let m;
                let n = this.bq(i, m, l);
                m = n.p1;
                l = n.p2;
                for (let p = 0; p < m.length; p++) {
                    let o = m[p];
                    if (typeof o === 'number') {
                        let q = Convert.toDouble3(o);
                        j = Math.min(j, q);
                        k = Math.max(k, q);
                    }
                }
                let r = d.item(g);
                d.item(g, Math.min(j, r));
                r = d.item(h);
                d.item(h, Math.min(j, r));
                r = e.item(g);
                e.item(g, Math.max(k, r));
                r = e.item(h);
                e.item(h, Math.max(k, r));
            }
            let s = -1.7976931348623157E+308;
            let t = 1.7976931348623157E+308;
            let u = -1.7976931348623157E+308;
            let v = 1.7976931348623157E+308;
            let w = 0;
            let x = 0;
            for (let y of fromEnum(a.b)) {
                if (typeCast(StraightNumericAxisBaseDescription.$, y.a) !== null) {
                    if (y.b.minimumScaleIsAuto) {
                        let z = Math.floor(d.item(y.a.name));
                        y.a.minimumValue = z;
                        if (y.j) {
                            x++;
                            v = Math.min(v, z);
                        }
                        else {
                            w++;
                            t = Math.min(t, z);
                        }
                    }
                    if (y.b.maximumScaleIsAuto) {
                        let aa = Math.ceil(e.item(y.a.name));
                        y.a.maximumValue = aa;
                        if (y.j) {
                            x++;
                            u = Math.max(u, aa);
                        }
                        else {
                            w++;
                            s = Math.max(s, aa);
                        }
                    }
                }
            }
            let ab = (ac, ad, ae) => {
                let af = Math.abs(ae - ad);
                return (af / (ad - ac)) <= 0.1;
            };
            let ac = (ad, ae, af) => {
                let ag = Math.abs(af - ad);
                return (ag / (ae - ad)) <= 0.1;
            };
            for (let ad of fromEnum(a.b)) {
                if (typeCast(StraightNumericAxisBaseDescription.$, ad.a) !== null) {
                    if (ad.b.minimumScaleIsAuto) {
                        if (ad.j) {
                            if (x > 1) {
                                let ae = ad.a.minimumValue;
                                if (ae != v && ac(v, u, ae)) {
                                    ad.a.minimumValue = v;
                                }
                            }
                        }
                        else {
                            if (w > 1) {
                                let af = ad.a.minimumValue;
                                if (af != t && ac(t, s, af)) {
                                    ad.a.minimumValue = t;
                                }
                            }
                        }
                    }
                    if (ad.b.maximumScaleIsAuto) {
                        if (ad.j) {
                            if (x > 1) {
                                let ag = ad.a.maximumValue;
                                if (ag != v && ab(v, u, ag)) {
                                    ad.a.maximumValue = u;
                                }
                            }
                        }
                        else {
                            if (w > 1) {
                                let ah = ad.a.maximumValue;
                                if (ah != t && ac(t, s, ah)) {
                                    ad.a.maximumValue = s;
                                }
                            }
                        }
                    }
                }
            }
        }
        b6() {
            if (false == this.ae._e.contains(this.c.chartType)) {
            }
        }
        av(a, b, c) {
            let d = 0;
            let e = 0;
            let f = 0;
            for (let g of fromEnum(this.c._axisCollection$i)) {
                if (g.type == 1 && g.visible) {
                    d++;
                }
                else if (g.axisGroup == 1 && g.visible) {
                    e++;
                }
                else if (g.axisGroup == 2 && g.visible) {
                    f++;
                }
            }
            return d == a && e == b && f == c;
        }
        b7(a) {
            let b = new HashSet$1(String_$type, 0);
            for (let c of fromEnum(a)) {
                let d = c.name;
                while (b.contains(d)) {
                    d = c.name + this.ag.e().toString();
                }
                b.add_1(d);
                if (c.name != d) {
                    c.name = d;
                }
            }
        }
        b8(a) {
            let b = new HashSet$1(String_$type, 0);
            for (let c of fromEnum(a)) {
                let d = c.name;
                while (b.contains(d)) {
                    d = c.name + this.ag.e().toString();
                }
                b.add_1(d);
                if (c.name != d) {
                    c.name = d;
                }
            }
        }
    }
    SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate.$t = /*@__PURE__*/ markType(SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate, 'SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate', SpreadsheetChartElementInfo.$);
    return SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AnchorStyle_$type = /*@__PURE__*/ markEnum('AnchorStyle', 'None,0|Top,1|Bottom,2|Left,4|Right,8');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let AxisGroupType_$type = /*@__PURE__*/ markEnum('AxisGroupType', 'PrimaryX,0|PrimaryY,1|SecondaryX,2|SecondaryY,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let DockingStyle_$type = /*@__PURE__*/ markEnum('DockingStyle', 'None,0|Top,1|Bottom,2|Left,3|Right,4|Fill,5');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let HAlign_$type = /*@__PURE__*/ markEnum('HAlign', 'Left,0|Center,1|Right,2|Stretch,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let RowColUnitType_$type = /*@__PURE__*/ markEnum('RowColUnitType', 'Auto,0|Pixel,1|Star,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let VAlign_$type = /*@__PURE__*/ markEnum('VAlign', 'Top,0|Center,1|Bottom,2|Stretch,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SpreadsheetChartAdapter_GroupedSeriesOrderBy_$type = /*@__PURE__*/ markEnum('SpreadsheetChartAdapter_GroupedSeriesOrderBy', 'Row,0|Col,1');

export { AnchorStyle_$type, AxisGroupType_$type, AxisInfo, AxisInfos, ChartElementPlatformHelper, ChartSeriesInfo, DockingStyle_$type, HAlign_$type, IgcSpreadsheetChartAdapterLocaleBgModule, IgcSpreadsheetChartAdapterLocaleCsModule, IgcSpreadsheetChartAdapterLocaleDaModule, IgcSpreadsheetChartAdapterLocaleDeModule, IgcSpreadsheetChartAdapterLocaleEnModule, IgcSpreadsheetChartAdapterLocaleEsModule, IgcSpreadsheetChartAdapterLocaleFrModule, IgcSpreadsheetChartAdapterLocaleHuModule, IgcSpreadsheetChartAdapterLocaleItModule, IgcSpreadsheetChartAdapterLocaleJaModule, IgcSpreadsheetChartAdapterLocaleNbModule, IgcSpreadsheetChartAdapterLocaleNlModule, IgcSpreadsheetChartAdapterLocalePlModule, IgcSpreadsheetChartAdapterLocalePtModule, IgcSpreadsheetChartAdapterLocaleRoModule, IgcSpreadsheetChartAdapterLocaleRuModule, IgcSpreadsheetChartAdapterLocaleSvModule, IgcSpreadsheetChartAdapterLocaleTrModule, IgcSpreadsheetChartAdapterLocaleZhHansModule, IgcSpreadsheetChartAdapterLocaleZhHantModule, IgcSpreadsheetChartAdapterModule, RowColLength, RowColUnitType_$type, SpreadsheetChartAdapter, SpreadsheetChartAdapterHelpers, SpreadsheetChartAdapterLocaleBg, SpreadsheetChartAdapterLocaleCs, SpreadsheetChartAdapterLocaleDa, SpreadsheetChartAdapterLocaleDe, SpreadsheetChartAdapterLocaleEn, SpreadsheetChartAdapterLocaleEs, SpreadsheetChartAdapterLocaleFr, SpreadsheetChartAdapterLocaleHu, SpreadsheetChartAdapterLocaleIt, SpreadsheetChartAdapterLocaleJa, SpreadsheetChartAdapterLocaleNb, SpreadsheetChartAdapterLocaleNl, SpreadsheetChartAdapterLocalePl, SpreadsheetChartAdapterLocalePt, SpreadsheetChartAdapterLocaleRo, SpreadsheetChartAdapterLocaleRu, SpreadsheetChartAdapterLocaleSv, SpreadsheetChartAdapterLocaleTr, SpreadsheetChartAdapterLocaleZhHans, SpreadsheetChartAdapterLocaleZhHant, SpreadsheetChartAdapterState, SpreadsheetChartAdapter_GroupedSeriesOrderBy_$type, SpreadsheetChartAdapter_PieDataItem, SpreadsheetChartAdapter_ScatterSeriesDataItem, SpreadsheetChartAdapter_SeriesDataItem, SpreadsheetChartAdapter_SpreadsheetChartElementInfoPrivate, SpreadsheetChartAdapter_StackedSeriesDataItem, SpreadsheetChartAdapter_StockDataItem, VAlign_$type };
